unit LittleDataSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,LittleDB;

type
  TLittleDataSet = class(TComponent)
  private
    fStructure,fRecords,fUpdateValues:TstringList;
    fRecord,fBlob:string;
    fIndex:integer;
    fDatabase:TLittleDatabase;
    fRelRecPos,fMaxRecCnt:integer;
    { Private declarations }
  protected
     procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    { Protected declarations }
  public
    destructor Destroy; override;
    constructor Create(aOwner: TComponent); override;
    { Public declarations }
  published
    { Published declarations }
  end;

procedure Register;

implementation

constructor TLittleDataSet.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  fMaxRecCnt:=90;
  fRelRecPos:=-1;
  fRecords:=TStringList.Create;
  fStructure:=TStringList.Create;
  fUpdateValues:=TStringList.Create;
end;

destructor TLittleDataSet.Destroy;
begin
  fUpdateValues.Free;
  fStructure.Free;
  fRecords.Free;
  inherited Destroy;
end;

procedure TLittleDataSet.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent=fDatabase) then begin
    fDatabase:=nil;
  end;
End;

procedure Register;
begin
  RegisterComponents('Samples', [TLittleDataSet]);
end;

end.
