unit uBlokEdit;

interface

uses Windows, Messages, SysUtils, Classes;

  function  BlokIndex(pName:string; pSource:TStringList):integer; // get blok begin line index
  procedure BlokNames(pSource,pDest:TStringList); //get all blok names from pSource to pDest
  procedure BlokBody(pName:String; pSource,pDest:TStringList); // get blok body
  procedure BlokEdit(pName:String; pSource,pDest:TStringList); // add, delete, edit blok
  function BlokValueIndex(pBlokName,pValName:String; pSource:TStringList):integer;
  function BlokValue(pBlokName,pValName:String; pSource:TStringList):String;
  procedure BlokValueEdit(pBlokName,pValName,pValue:String; pDest:TStringList);
  (* BlokEdit :
     if pSource is Empty - delete existing pName blok
     if pSource is not empty and pName exists then
     delete pName blok and add pSource to end pDest *)

implementation
const cBegin='BLOK_NAME=';
      cEnd='BLOK_END;';

function BlokIndex(pName:string; pSource:TStringList):integer;
var b:boolean;
    i:integer;
begin
  result:=-1;
  pName:=Trim(AnsiLowerCase(pName));
  if pName='' then exit;
  if pName[Length(pName)]<>';' then pName:=pName+';';
  for i:=0 to pSource.Count-1 do begin
    b:=Pos(cBegin+pName,pSource.Strings[i])=1;
    if b then begin result:=i; break; end;
  end;
end;

procedure BlokNames(pSource,pDest:TStringList);
var i:integer;
begin
  for i:=0 to pSource.Count-1 do begin
    if Pos(cBegin,pSource.Strings[i])=1 then
     pDest.Add(Trim(copy(pSource.Strings[i],Length(cBegin)+1,255)));
  end;
end;

function BlokValueIndex(pBlokName,pValName:String; pSource:TStringList):integer;
var i,j:integer;
    b:boolean;
begin
  result:=-1;
  j:=BlokIndex(pBlokName,pSource);
  if j<0 then exit;
  pBlokName:=Trim(AnsiLowerCase(pBlokName));
  pValName:='@'+Trim(AnsiLowerCase(pValName))+'=';
  for i:=j+1 to pSource.Count-1 do begin
    b:=Pos(cEnd,pSource.Strings[i])=1;
    if b then break;
    if Pos(pValName,Trim(pSource.Strings[i]))=1 then begin
      result:=i;
      exit;
    end;
  end;
end;

function BlokValue(pBlokName,pValName:String; pSource:TStringList):String;
var j:integer;
begin
  result:='';
  j:=BlokValueIndex(pBlokName,pValName,pSource);
  if j=-1 then exit;
  pValName:='@'+Trim(AnsiLowerCase(pValName))+'=';
  result:=copy(pSource.Strings[j],Length(pValName)+1,500);
end;

procedure BlokValueEdit(pBlokName,pValName,pValue:String; pDest:TStringList);
var j,i:integer;
begin
  j:=BlokValueIndex(pBlokName,pValName,pDest);
  pValue:=Trim(pValue);
  pValName:='@'+Trim(AnsiLowerCase(pValName))+'=';
  if pValue='' then begin
    if j=-1 then exit;
    pDest.delete(j);
  end else begin
    if j=-1 then begin
      i:=BlokIndex(pBlokName,pDest);
      if i=-1 then exit;
      pDest.Insert(i+1,pValName+pValue);
    end else begin
      pDest.Strings[j]:=pValName+pValue;
    end;
  end;
end;

procedure BlokBody(pName:String; pSource,pDest:TStringList);
var i,j:integer;
    b:boolean;
begin
  j:=BlokIndex(pName,pSource);
  if j<0 then exit;
  pName:=Trim(AnsiLowerCase(pName));
  if pName='' then exit;
  if pName[Length(pName)]<>';' then pName:=pName+';';
  for i:=j+1 to pSource.Count-1 do begin
    b:=Pos(cEnd,pSource.Strings[i])=1;
    if b then break;
    if Pos('@',Trim(pSource.Strings[i]))<>1 then pDest.add(pSource.Strings[i]);
  end;
end;

procedure BlokEdit(pName:String; pSource,pDest:TStringList);
var i,j,k:integer;
    b:boolean;
begin
  j:=BlokIndex(pName,pDest);
  pName:=Trim(AnsiLowerCase(pName));
  if pName='' then exit;
  if pName[Length(pName)]<>';' then pName:=pName+';';
  if j>-1 then begin
    k:=pSource.Count-1;
    for i:=j+1 to pDest.Count-1 do begin
      b:=Pos(cEnd,pDest.Strings[i])=1;
      if b then begin k:=i; break; end;
    end;
    for i:=k downto j do pDest.Delete(i);
  end;
  if pSource.count>0 then begin
    pDest.add(cBegin+pName);
    for i:=0 to pSource.Count-1 do begin
      if Trim(pSource.Strings[i])<>'' then pDest.add(pSource.Strings[i]);
    end;
    pDest.add(cEnd);
  end;
end;

end.
