unit uDataCopyDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Tabnotbk, Buttons, Db, DBTables, uRozne;

type
  TF_TargetTables = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Edit1: TEdit;
    ComboBox4: TComboBox;
    Edit2: TEdit;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    ListBox2: TListBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Edit3: TEdit;
    Label11: TLabel;
    ListBox3: TListBox;
    Label12: TLabel;
    ListBox4: TListBox;
    SpeedButton1: TSpeedButton;
    Label13: TLabel;
    ListBox5: TListBox;
    SpeedButton2: TSpeedButton;
    Button3: TButton;
    Button4: TButton;
    Table1: TTable;
    Label14: TLabel;
    Memo2: TMemo;
    SpeedButton3: TSpeedButton;
    Query1: TQuery;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private

    fFirst:boolean;
    fTbl,fFld:TStringList;
    fQ:TQuery;
    fEdit:Tedit;
    fCancel:boolean;
    function  NewTable:string;
    procedure AddObjects;
    procedure AddFields;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_TargetTables: TF_TargetTables;

  procedure Execute_Dialog(pTbl,pFld:TStringList; pSource:TQuery);

implementation

{$R *.DFM}

procedure Execute_Dialog(pTbl,pFld:TStringList; pSource:TQuery);
begin
  if F_TargetTables=nil then Application.CreateForm(TF_TargetTables,F_TargetTables);
  F_TargetTables.ModalResult:=mrCancel;
  try
    F_TargetTables.fQ:=pSource;
    F_TargetTables.fTbl:=pTbl;
    F_TargetTables.fFld:=pFld;
    F_TargetTables.ShowModal;
  finally
    if not F_TargetTables.fCancel then begin
      pFld.text:=F_TargetTables.ListBox5.items.text;
      pTbl.text:=F_TargetTables.memo1.lines.text;
    end;
    F_TargetTables.Free;
    F_TargetTables:=nil;
  end;
end;

procedure TF_TargetTables.FormCreate(Sender: TObject);
begin
  fFirst:=true;
  TabbedNotebook1.pageIndex:=0;
end;

function TF_TargetTables.NewTable:string;
var i:integer;
    mS:String;
begin
  for i:=1 to 50 do begin
    mS:='T'+IntToStr(i)+'_DatabaseName';
    if Pos(mS,memo1.Lines.text)=0 then begin
      result:='T'+IntToStr(i);
      exit;
    end;
  end;
end;


procedure TF_TargetTables.FormActivate(Sender: TObject);
var mB:boolean;
    i:integer;
begin
  if fFirst then begin
    fFirst:=false;
    memo1.Lines.Clear;
    Memo1.Lines.text:=fTbl.Text;
    edit3.text:=NewTable;
    ListBox2.Items.Clear;
    ListBox4.Items.Clear;
    ComboBox2.Items.Clear;
    Session.GetDatabaseNames(ComboBox2.Items);
    ComboBox3.Items.Clear;
    ListBox5.Items.Clear;
    ListBox5.Items.text:=fFld.text;
    mB:=fQ.active;
    try fQ.Active:=true;
    except
      MessageDlg('EDataCopy - Source query '+fQ.Name+'.open error',mterror,[mbOk],0);
      PostMessage(Handle,WM_close,0,0);
    end;
    if fQ.Active then begin
      for i:=0 to fQ.Fields.count-1 do begin
        ListBox2.Items.add(fQ.Fields[i].FieldName);
        ListBox4.Items.add(fQ.Fields[i].FieldName);
      end;
      if not mB then fQ.Active:=false;
    end;
  end;
end;

procedure TF_TargetTables.ComboBox2Change(Sender: TObject);
begin
  Session.GetTableNames(comboBox2.text, '*.*',true,false, ComboBox3.Items);
  ListBox1.Items.Clear;
end;

procedure TF_TargetTables.ComboBox3Change(Sender: TObject);
var i:integer;
begin
 ListBox1.Items.Clear;
 Table1.Active:=false;
 Table1.dataBaseName:=ComboBox2.Text;
 Table1.tableName:=ComboBox3.text;
 Table1.Active:=true;
 for i:=0 to Table1.Fields.count-1 do ListBox1.Items.add(Table1.Fields[i].FieldName);
 Table1.Active:=false;
end;

procedure TF_TargetTables.ComboBox4Change(Sender: TObject);
var mS:String;
    mA,mB:boolean;
begin
  mS:=trim(ComboBox4.text);
  if mS='' then exit;
  case mS[1] of
  '1':begin mA:=true; mB:=false; end;
  '2':begin mA:=false; mB:=true; end;
  '3','4':begin mA:=true; mB:=true;end;
  end;
  if mA then begin
    edit1.enabled:=true; edit1.Color:=clWindow;
    edit1.SetFocus;
  end else begin
    edit1.text:='';edit1.enabled:=false; edit1.Color:=clSilver;
  end;
  if mB then begin
    edit2.enabled:=true; edit2.Color:=clWindow;
    edit2.SetFocus;
  end else begin
    edit2.text:=''; edit2.enabled:=false; edit2.Color:=clSilver;
  end;
end;

procedure TF_TargetTables.ListBox1DblClick(Sender: TObject);
begin
  if fEdit<>nil then begin
    if fEdit.Enabled=false then exit;
    fEdit.text:=fEdit.text+ListBox1.Items.Strings[ListBox1.ItemIndex]
  end;
end;

procedure TF_TargetTables.ListBox2DblClick(Sender: TObject);
begin
  if fEdit<>nil then begin
    if fEdit.Enabled=false then exit;
    fEdit.text:=fEdit.text+'{{'+ListBox2.Items.Strings[ListBox2.ItemIndex]+'}}'
  end;
end;

procedure TF_TargetTables.Button1Click(Sender: TObject);
begin
  if Trim(ComboBox4.text)='' then begin
    MessageDlg('Write mode=?',mtWarning,[mbOk],0);
    ComboBox4.setFocus;
    exit;
  end;
  with memo1.Lines do begin
    add('');
    add(edit3.text+'_DatabaseName='+ComboBox2.text);
    add(edit3.text+'_TableName='+ComboBox3.text);
    add(edit3.text+'_WriteMode='+copy(ComboBox4.text,1,1));
    if edit2.text<>'' then add(edit3.text+'_Update='+edit2.text);
    if edit1.text<>'' then add(edit3.text+'_Insert='+edit1.text);
  end;
  ComboBox3.Items.Clear;
  ComboBox2.Items.Clear;
  Session.GetDatabaseNames(ComboBox2.Items);
  Edit3.text:=newTable;
  Edit2.text:='';
  Edit1.text:='';
  ComboBox4.text:='';
  ListBox1.Items.Clear;
end;

procedure TF_TargetTables.ComboBox1Change(Sender: TObject);
var i:integer;
begin
  memo2.lines.Clear;
  if Trim(ComboBox1.text)='' then exit;
  for i:=0 to memo1.Lines.count-1 do begin
    if Pos(ComboBox1.text+'_',memo1.Lines.Strings[i])=1 then begin
      memo2.Lines.add(memo1.Lines.Strings[i]);
    end;
  end;
end;

procedure TF_TargetTables.AddObjects;
var i,j:integer;
    mT:String;
begin
  ComboBox1.Items.Clear;
  memo2.Lines.Clear;
  for i:=0 to memo1.Lines.count-1 do begin
    j:=Pos('_',memo1.Lines.Strings[i]);
    if j>0 then begin
      mT:=copy(memo1.Lines.Strings[i],1,j-1);
      If ComboBox1.Items.IndexOf(mT)=-1 then ComboBox1.Items.add(mt);
    end;
  end;
end;

procedure TF_TargetTables.AddFields;
var i,j:integer;
   mS,mT,mD:String;
begin
  ListBox3.items.Clear;
  for i:=1 to 50 do begin
    mD:=''; mT:='';
    j:=TStringList(memo1.Lines).IndexOfName('T'+IntToStr(i)+'_TableName');
    if j>-1 then begin
      Table1.Active:=false;
      mT:=memo1.Lines.Strings[j];
      j:=Pos('=',mT);
      mT:=trim(copy(mT,j+1,255));
      Table1.TableName:=mT;
      j:=TStringList(memo1.Lines).IndexOfName('T'+IntToStr(i)+'_DatabaseName');
      if j>0 then begin
        mD:=memo1.Lines.Strings[j];
        j:=Pos('=',mD);
        mD:=trim(copy(mD,j+1,255));
      end;
      Table1.dataBaseName:=mD;
      try Table1.Active:=true; except end;
      if Table1.Active then begin
        for j:=0 to Table1.Fields.count-1 do begin
          ListBox3.Items.add('T'+IntToStr(i)+'.'+Table1.Fields[j].FieldName);
        end;
      end;
      Table1.Active:=false;
    end;
  end;
  ListBox5.ItemIndex:=0;
  ListBox4.ItemIndex:=0;
  ListBox3.ItemIndex:=0;
end;

procedure TF_TargetTables.TabbedNotebook1Change(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
var i,j:integer;
    mT:String;
begin
  if NewTab=2 then AddObjects;
  if NewTab=1 then AddFields;
end;

procedure TF_TargetTables.Button2Click(Sender: TObject);
var i:integer;
    mT:string;
begin
  if Trim(ComboBox1.text)='' then exit;
  mT:=Trim(ComboBox1.text);
  for i:=memo1.Lines.count-1 downto 0 do begin
    if Pos(mT+'_',memo1.Lines.Strings[i])=1 then memo1.Lines.delete(i);
  end;
  for i:=ListBox5.items.count-1 downto 0 do begin
    if Pos('='+mT+'.',ListBox5.Items.Strings[i])>0 then ListBox5.Items.delete(i);
  end;
  AddObjects;
end;

procedure TF_TargetTables.SpeedButton1Click(Sender: TObject);
begin
  if ListBox3.ItemIndex<0 then exit;
  if ListBox4.ItemIndex<0 then exit;
  ListBox5.Items.add(ListBox4.Items.Strings[ListBox4.ItemIndex]+'='+ListBox3.Items.Strings[ListBox3.ItemIndex]);
end;

procedure TF_TargetTables.SpeedButton2Click(Sender: TObject);
begin
 if ListBox5.ItemIndex<0 then exit;
 ListBox5.Items.delete(ListBox5.ItemIndex);
end;

procedure TF_TargetTables.Edit1Exit(Sender: TObject);
begin
  fEdit:=Edit1;
end;

procedure TF_TargetTables.Edit2Exit(Sender: TObject);
begin
  fEdit:=Edit2;
end;

procedure TF_TargetTables.Button3Click(Sender: TObject);
begin
  close;
end;

procedure TF_TargetTables.Button4Click(Sender: TObject);
begin
  fCancel:=true;
  close;
end;

procedure TF_TargetTables.SpeedButton3Click(Sender: TObject);
var mS,mT:String;
    i:integer;
begin
  if MessageDlg('Do you want clear data?',mtConfirmation,[mbyes,mbNo],0)=mrNo then exit;
  Query1.Active:=false;
  Query1.SQL.Clear;
  Query1.DataBaseName:='';
  for i:=0 to memo2.Lines.count-1 do begin
    mS:=delSpaces(UpperCase(memo2.Lines.Strings[i]));
    if Pos('_DATABASENAME=',mS)>0 then begin
      Query1.databaseName:=copy(mS,Pos('=',mS)+1,255);
    end;
    if Pos('_TABLENAME=',mS)>0 then begin
      mT:=copy(mS,Pos('=',mS)+1,255);
      Query1.sql.add('delete from '+mT);
    end;
  end;
  try Query1.ExecSQL; except ShowMessage('clear error'); end;
  if (Pos('.DBF',UpperCase(mT))>0) then begin
    mS:=AliasPath(Query1.dataBaseName);
    mS:=mS+mT;
    try PackDBFTable(mS); except ShowMessage('pack error'); end;
  end;
end;

END.
