unit uEDBGrid;
(* TEDBGrid a TEFilter component ver 1.5

EDBGrid:
   autor: Jan TUNGLI '2000, email: jan.tungli@seznam.cz

   Pozor: komponenta funguje iba na spojenie cez Query (nie cez Table)
   Pozor: komponenta funguje korektne iba ak Query.DataBaseName nie je prazdne
          a nazov tabuliek v SQL dotaze su bez extension a bez cesty.
          napr.: select * fom COUNTRY.DB -> spravne: select * from COUNTRY
   Pozor: V Query.SQL v segmente FROM a segmente SELECT nemoze byt vnoreny select
          v ostatnych segmentoch napr. vo WHERE uz mozu byt vnorene selecty
          Kalkulovane polozky treba pisat cez AS  napr. MAX(C) as M
                                                        a+b as C

Komponenta EDBGrid
 OnDraw udalost je nahradou za udalost OnDrawColumnCell
 lebo udalost OnDrawColumnCell privlastni EDBGrid -
 Miesto OnDrawColumnCell je treba pouzit udalost OnDraw;

 Je mozne zadat ake vnorenie indexov povolujeme cez property:
   OrderFieldCount, defult je 3 (primar a secundar ,subsecundar indexovanie) max.10

 OrderedFiedsNo property ma vyznam iba ak EDBGrid nema komponentu EFilter.
 Do property OrderedFieldsNo treba zapisat idexy poloziek (napr. 1,-3,5)
 podla ktorych je pri starte triedenie v SQL. Zaporne cislo znamena DESCENDING zoradenie polozky.
 OderedFieldsNo property je iba nato aby pri zobrazeni EGridu boli spravne
 umiestnene sipky na polozky - sipkami su oznecene indexovane polozky.
 Ak OrderedIndex nechate prazdne vsetko bude fungovat ale
 pri zaciatku nezobrazia sipky vedla poloziek podla ktorych su data indexovane.
 OrderedFieldsNo ma byt kopia order by vyrazu z SQL dotazu v cislach.
 Prioritny je SQL dotaz. To znamena ak OrderedFieldsNo nekoresponduje s SQL
 order by vyrazom tak indexovanie bude podla SQL dotazu ale v EDBGride na zaciatku
 budu zle zobrazene sipky.

 Dolezite je ze ak k EDBGrid prilinkujeme EFilter komponentu, tak
 pri prvom vykresleni sa aktivizuje CreateFieldList procedura, ktora
 uroby rozklad dotazu a zapise polozky do Fields property (oFlds).
 Procedura CreateFieldList moze byt v run time casovo velmi narocny !!!
 preto je mozne tento rozklad SQL dotazu urobit v design time cez
 Fields_Create (true) ktory inicializuje Fields property.

 Doporucuje pridat PopupMenu na EDBGrid
 Ak je k EDBGrid pridany PopupMenu tak automaticky v runtime
 prida na koniec PopupMenu polozky:
   1.Vloi do schrnky CTRL-C   (ako text so separatorom Tab)
   ak je povoleny MultiSelect:
     2.Vybra vetko CTRL-A
     3.Opan vber CTRL-Z
   4.Vyhada  CTRL-F
   5.Refresh  CTRL-R
   6.SQL CTRL-F11
  (planuje sa do verze 2.0 urobit aj moznost vytvorenia filtrov)

 Ak EDBGrid ma EFilter objekt tak pri : 4.Vyhada  CTRL-F
 aktivizuje EFilter


 Tiez doporucujem v EDBGgride s Culomns editorom priradit polozky. Ak su polozky
 pridane do colums editoru potom premiestnenie slpcov bude korekne aj po reindex.

Vlastnosti pouzitia:
 Pri click na titulny pruh aktivizuje index na danu polozku.

 Komponenta zabezpecuje pri MultiSelect standarny Windows sluzby ako v expoery:
   Mouse:
     Down + Move     - select/unselect block
     Ctrl+Down+ Move - select/unselect next block
     Ctrl+Click      - row select/unselect
   Key:
     Shift + Up/Dn - select/unselect row
     CTRL  + Up/Dn - only move the next/prev row
     CTRL + C      - selectedblock copy to clipboard
     CTRL + A      - select All - ak je multiSelect
     CTRL + Z      - opacny vyber - ak je multiSelect (nie je Win standard)
     CTRL + F      - vyhladavanie - Find
     CTRL + R      - refresh
     CTRL + F11    - ukaze SQL dotaz (nie je Win standard)

  Dolezite metody:
  function GetSelectFieldVal(pFieldName:string):string;
    vrati string, ktory obsahuje vyselectovane hodnoty polozky pFieldName
    oddelene s ciarkou. Vysledok je potom mozne pouzit v SQL dotazoch
    napr:
     'SELECT * FROM Table  WHERE :pFieldName IN (:EDBGrid1.GetSelectFieldVal(pFieldName))'

 Metody pre rozklad a modifikovanie SQL dotazu:
    SQL.text:=Query1.SQL.text;
    SQLPase_m:=true;         -  rozkald SQL dotazu - je potrebne vzdy zavolat
 alebo miesto tychto dvoch riadkov :
    QueryParse_m:=true      - urobi rozkald SQL prilinkovanej Query;

 Potom je mozne pouzit:
    SQLModify:='select A,B'      modifikuje select segment v SQL.text
    SQLModify:='where'           zrusi where segment v SQL.text
    SQLModify:='where A>10'      modifikuje where segment v SQL.text
    Vysledok :
      AcceptSQL; - ktory vykona ->Query.Clear; Query.SQL.text:=EDBGrid1.SQL.Text;Query.Active:=true;

    function GetSQLSegment(pKeyWord:string):string;
    vrati SQL segment napr:
      GetSQLSegment('select') -> 'select A, B'
      GetSQLSegment('where') -> 'where A>10'

EFilter:
   Treba napojit na EDBGrid
       Mozete nastavit vlastnosti:
          Single   - vyskusajte
          Relation - default relacia pri filtrovani

 *)


interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids,DB, DBTables, Menus, Clipbrd,stdctrls,extctrls;
const
  UM_AKCE = WM_USER + 101; // prekreslovanie
  UM_Prior= WM_USER + 102; // posun hore
  UM_Next = WM_USER + 103; // posun dolu
  UM_EditClose = WM_User + 104; // odstrani fEdit - pri Find
type
  T_MyFieldType=( ff_sql, ff_dataset, ff_title, ff_no, ff_sqltable);
  T_ERelation=( f_Includes,f_Begines,f_MoreEq,f_LessEq, f_Eq, f_NotIn, f_UnEq);
  TMouseEventBefore= procedure (Sender: TObject;var Button: TMouseButton; var Shift: TShiftState;var Inherit:boolean; X, Y: Integer) of object;
  TSQLParseRec=record A,B:word; W: String; end;
  TLanguage=(l_Slovak,l_English);

  TEDBGrid = class(TDBGrid)
  private
    fLang:Tlanguage;
    fAddFields:TStringList;
    fDraw:TDrawColumnCellEvent;
    fOrderedFields:string;
    fOKGrid:TNotifyEvent;
    fSel:boolean;
    fOrderTitle,fOrderName:string;
    fUp:boolean; fYUp:integer; fDblClick:boolean;
    fHist:string;
    fEdit:Tedit;
    fLabel:TStaticText;
    fMouseDown,fDisableTitle:boolean;
    fY,fX,fOldY,fOldOldY:integer; // Y koordinaty mouse pri fMouseDown:=true;
    fPost:boolean;   // pre prekreslovanie
    fColumnMoved:boolean; //ci sa presuva Column title
    fMDA:TMouseEvent;   // udalost OnMouseDownAfter
    fMDB:TMouseEventBefore; // udalost OnMouseDownBefore
    fOrderCnt:integer;      // pocet indexovatelnch poloziek
    fOrder:array[1..10] of integer;  // indexovane polozky
    fOrderDESC:array[1..10] of boolean; // ci je polozka descending alebo nie
    //fOrdered:string; // pri starte podla ktorych poloziek je index, napr. 1,2
    fNewItem0,fNewItem1,fNewItem2,fNewItem3,fNewItem4,fNewItem5,fNewItem6:TmenuItem;
    fEnterSelect:boolean;
    fGridFilter:TPanel;
    fMouseMoveSelect:boolean;
    fShowSQL:boolean;
    // Nasleduju veci SQLParse
    oSyntax:TStringList;
    oSQL:TStringList;
    oChange :string;
    oWords:array[1..20] of TSQLParseRec;
    oOldSQL:string; // pre parse
    oParse:boolean;
    oNotParse:boolean;
    oAddToWhere:string;
    oParseQuery:boolean;
    fColumn: TColumn; {pomocna pre UMAkce2 - drawIndex}
    fRect: TRect;
    fCreateFlds:boolean;
    procedure SetSyntax(Value:TStringList);
    procedure SetSQL(Value:TStringList);
    procedure SetChange(pS:String);
    procedure Parse(pS:String);   //SQL parse
    procedure AddSegment(pKeyWord,pSegment:string); // POMOCNA PROCEDURA
    procedure ChangeSQL(pSegment:string);
    procedure UMAkce(var Msg: TMessage); message UM_AKCE;
    procedure UMPrior(var Msg: TMessage); message UM_Prior;
    procedure UMNext(var Msg: TMessage); message UM_Next;
    procedure UMEditClose(var Msg: TMessage); message UM_EditClose;
    procedure MyClick1(sender:TObject);  // CTRL-C Copy to Clipboard
    procedure MyClick2(sender:TObject);  // CRTL-A Vybrat vetko
    procedure MyClick3(sender:TObject);  // CTRL-Z Opan vber
    procedure MyClick4(sender:TObject);  // CTRL-F11 - SQL
    procedure MyClick5(sender:Tobject);  // CTRL-F; Find
    procedure MyClick6(sender:Tobject);  // CTRL-R; refresh
    procedure ReOrder(Column:TColumn);   //reindexacia
    procedure MyFind;                    // vyhadanie
    procedure EditKeyPress (sender:TObject; var Key: Char);
    procedure EditExit(sender:tObject);
    procedure EditKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SetFlds(pF:TStringList);
    procedure CreateFieldList;
    procedure SetParse(pB:boolean);
    procedure SetAddToWhere(pS:String);
    procedure SetParseQuery(pB:boolean);
    procedure SetOrderedFieldsNo(pOrderedFieldsNo:String);
    procedure SetfCreateFlds(pB:boolean);
    procedure SetfAddFields(pS:TStringList);
    { Private declarations }
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure DblClick; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer); override;
    procedure TitleClick(Column: TColumn);override;
    procedure ColumnMoved(FromIndex,ToIndex: Integer);override;
    procedure KeyDown(var Key: Word;Shift: TShiftState); override;
    procedure KeyUp(var Key: Word;Shift: TShiftState); override;
    procedure DoEnter; override;
    //procedure SetOrderedFieldsNo(pOrderedFieldsNo:String);
    procedure CreateFind;
    procedure addHist(pC:string);
    //procedure KeyPress (var Key: Char); override;
  public
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    { Public declarations }
  published
    oFlds:TStringList;
    property MyAdditionFields:TStringList read fAddFields write SetfAddFields;
    property OrderFieldCount:integer read fOrderCnt write fOrderCnt;
    property OrderedFieldsNo:string read fOrderedFields write SetOrderedFieldsNo;
    property ActOrderFieldName:string read fOrderName;
    property OnMouseDownBefore : TMouseEventBefore read fMDB write fMDB;
    property OnMouseDownAfter : TMouseEvent read fMDA write fMDA;
    property OnMXGridStart: TNotifyEvent read fOKGrid write fOKGrid;
    property OnDraw:TDrawColumnCellEvent read fDraw write fDraw;
    property EnterSelect:boolean read fEnterSelect write fEnterSelect;
    property SQLSyntax:TStringList read oSyntax write SetSyntax; // deklaruje SQL segmenty
    property SQL:TStringList read oSQL write SetSQL;
    property SQLPase_m:boolean read oParse write SetParse;
    property QueryParse_m:boolean read oParseQuery write SetParseQuery;
    property MyFields_Create:boolean read fCreateFlds write SetfCreateFlds;
    property MyFields:TStringList read oFlds write SetFlds;
    property SQLModify:string read oChange write SetChange; // modifikuje jeden SQL segment
    property SQLAddToWhere:string read oAddToWhere write SetAddToWhere; // prida do Where prodmineky
    property MouseMoveSelect:boolean read fMouseMoveSelect write fMouseMoveSelect;
    property ShowSQL:boolean read fShowSQL write fShowSQL;
    property Language:Tlanguage read fLang write fLang;
    //
    procedure DrawIndex(Sender: TObject;const Rect: TRect; DataCol: Integer; Column: TColumn;
       State: TGridDrawState); // vykresluje index sipky
    function GetSQLSegment(pKeyWord:string):string;  // vrati SQL segment napr.
    //GetSQLSegment('select') = 'select Alfa, Beta'
    //GetSQLSegment('where') = 'where A>10'
    function GetSelectFieldVal(pFieldName:string):string;
    procedure SelectAll;
    function RecordCount:integer;
    procedure NewQuery(pCreateFieldsInfo:boolean=true);// ak zvonka zmeni Query
    function GetHist:string;
    function NextPos(pPos:integer;pVal,pS:string):integer;
    function ABCopy(pS:string; pA,pB:integer):string;
    function Zatvorka(pA:integer; pS:string):integer;
    function GetTableNames:string; // all tables form Database
    function GetFieldName(pName:string; pFrom,pTo:T_MyFieldType):string;
    procedure RefreshFieldList;
    procedure DeleteFromWhere(pS:String);
    function  GetOrderTitleName:string;
    procedure SeTEFilter(pP:TPanel);
    procedure AcceptSQL(AOpen:Boolean=false);
    procedure Unselect;
    { Published declarations }
  end;

  TEFilter = class(TPanel)
  private
    fOldText,fOldFilter:string;
    fActive:boolean;
    fExecute:boolean;
    fRelType:T_ERelation;
    fGrid:TEDBGrid;
    fSingle:boolean;
    fEdit1,fEdit2:TEdit;
    fButton:TButton;
    fFilter:string;
    fPop:tPopupMenu;
    fNewItemA,fNewItemB,fNewItem0,fNewItem1,fNewItem2,fNewItem3,fNewItem4,fNewItem5,fNewItem6,fNewItem7,fNewItem8:TMenuItem;
    fDefRel:string;   // default relacia
    fViazat:boolean;
    fFindChange:boolean; // ci ma vyhladat pokazdej zmene
    fEnter:TNotifyEvent;
    fAfterFiltered:TNotifyEvent;
    procedure StartPopup(sender:TObject);
    procedure ButtonClick(sender:TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure SetGrid(pG:TEDBGrid);
    procedure SetSingle(pB:boolean);
    procedure MyResize;
    procedure ReplaceToSQLName(var pS:string);
    function Viazat(pS:string):string;
    procedure MyClickA(sender:TObject);
    procedure MyClick1(sender:TObject);
    procedure MyClick2(sender:TObject);
    procedure SetRelType(pRel:T_ERelation);
    function GetText:String;
    procedure SetText(pS:string);
    function GetText2:String;
    procedure SetText2(pS:string);
    procedure Dotaz;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    function GetFocused:boolean ;
    procedure SetCaptions;
    { Private declarations }
  protected
    procedure  Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Resize; override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    procedure SetFocus; override;
    procedure SelectAll;
    procedure SelStart(pI:integer);
    { Public declarations }
  published
    property Active:boolean read fActive write fActive;
    property MyFocused:boolean read GetFocused ;
    property OnKeyEnter: TNotifyEvent read fEnter write fEnter;
    property OnAfterFiltered: TNotifyEvent read fAfterFiltered write fAfterFiltered;
    //OnkeyEnter udalost sa neastene ak FindChage=true alebo je stalceny ENTER alebo DblClick;
    property EDBGrid:TEDBGrid read fGrid write SetGrid;
    property Single:boolean read fSingle write SetSingle;
    property Relation:T_ERelation read fRelType write SetRelType;
    property Text:string read GetText write SetText;
    property Text2:string read GetText2 write SetText2;
    property FindChange:boolean read fFindChange write fFindChange;
    // FindChage - ci ma hladat pri kazdom zmene
    procedure Edit2Refresh;
    procedure Vyber;
    procedure Execute;
    { Published declarations }
  end;

procedure Register;

implementation
uses uGridFields, uDB_SQL_View;

Constructor TEDBGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fHist:='XXX';
  fMouseMoveSelect:=true;
  fEnterSelect:=true;
  OnDrawColumnCell:=DrawIndex;
  oSQL:=TStringList.Create;
  oFlds:=TStringList.Create;
  fAddFields:=TStringList.Create;
  fOrderCnt:=3;
  fOrder[1]:=-1;
  oOldSQL:='';
  oSQL.Clear;
  oSyntax:=TStringList.Create;
  Options:=[dgTitles,dgIndicator,dgColumnResize,dgColLines,
            dgRowLines,dgCancelOnExit];
  with oSyntax do begin
    Clear;
    Add('SELECT');  // SELECT must by first keyword
    Add('FROM');
    Add('WHERE');
    Add('GROUP');
    Add('HAVING');
    Add('UNION');
    Add('PLAN');      // Interbase
    Add('ORDER');
    Add('COMPUTE');   // for MS_SQL
    Add('FOR');       // MS_SQL: FOR BROWSE or INTERBASE: FOR UPDATE
    Add('INTO');      // for INFORMIX  (into temp)
  end;
end;

Destructor TEDBGrid.Destroy;
begin
  //try
  // PostMessage(Handle,UM_EditClose,0,0);
  //finally
    Application.ProcessMessages;
    if oSyntax<>nil then oSyntax.Free;
    if oSQL<>nil then oSQL.Free;
    if oFlds<>nil then oFlds.Free;
    if fAddFields<>nil then fAddFields.Free;
  //end;
  inherited Destroy;
End;

procedure TEDBGrid.AcceptSQL(AOpen:boolean=false);
begin
  if DataSource=nil then exit;
  if DataSource.DataSet=nil then exit;
  if DataSource.DataSet is TQuery then begin
    with TQuery(DataSource.Dataset) do begin
      Close;
      SQL.Clear;
      SQL.text:=Self.SQL.text;
      if AOpen then Open;
    end;
  end;
end;

procedure TEDBGrid.NewQuery(pCreateFieldsInfo:boolean=true);
begin
  fOrder[1]:=-1;
  if pCreateFieldsInfo then oFlds.Clear;
end;

procedure TEDbGrid.SeTEFilter(pP:TPanel);
begin
  if pP is TEFilter then fGridFilter:=pP;
end;

procedure TEDBGrid.CreateFind;
begin
  if Flabel=nil then begin
    FLabel:=TStatictext.Create(Self.owner);
    FLabel.Parent:=TWinControl(Self.owner);
    FLabel.Name:='Label_MX1';
    FLabel.Visible:=false;
    Fedit:=TEdit.Create(self.owner);
    Fedit.Parent:=TWinControl(self.owner);
    Fedit.Name:='EdiT_E21';
    Fedit.text:='';
    Fedit.Hint:='Vyhadvanie';
    Fedit.ShowHint:=true;
    Fedit.Color:=clWindow;
    FEdit.OnKeyPress:=EditKeyPress;
    FEdit.OnKeyDown:=EditKeyDown;
    FEdit.OnExit:=EditExit;
    Fedit.Visible:=false;
    Flabel.Font.Color:=clNavy;
    FEdit.Font.Color:=clNavy;
    Fedit.Ctl3D:=false;
  end;
end;

procedure TEDBGrid.SetOrderedFieldsNo(pOrderedFieldsNo:String);
var mS:String;
    i:integer;
begin
  if fOrderCnt>10 then fOrderCnt:=10;
  if fOrderCnt<0 then fOrderCnt:=0;
  mS:=fOrderedFields;
  fOrderedFields:=Trim(pOrderedFieldsNo);
  while Pos(' ',fOrderedFields)>0 do delete(fOrderedFields,Pos(' ',fOrderedFields),1);
  while Pos(';',fOrderedFields)>0 do fOrderedFields[Pos(';',fOrderedFields)]:=',';
  while Pos(',,',fOrderedFields)>0 do delete(fOrderedFields,Pos(',,',fOrderedFields),1);
  if fOrderedFields='' then exit;
  if not(fOrderedFields[1] in ['-','1'..'9',',']) then begin
    MessageDlg('OrderedFieldsNo: obsahuje nepovolen znaky',mtError,[mbOk],0);
    fOrderedFields:=mS;
    Exit;
  end;
  for i:=1 to Length(fOrderedFields) do begin
    if not(fOrderedFields[i] in ['-','0'..'9',',']) then begin
      MessageDlg('OrderedFieldsNo: obsahuje nepovolen znaky',mtError,[mbOk],0);
      fOrderedFields:=mS;
    end;
  end;
end;

procedure TEDBGrid.EditKeyPress (Sender:TObject;var Key: Char);
begin
 // nic
end;

procedure TEDBGrid.EditExit(Sender:Tobject);
begin
  PostMessage(Handle,UM_EditClose,0,0);
end;

procedure TEDBGrid.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Shift=[] then begin
    if (Key=VK_Up) or (Key=Vk_Down) then begin Key:=0; SetFocus; end;
    if (Key=9) or (key=27) then begin
      key:=0;SetFocus;
    end;
    if Key=13 then begin Key:=0; MyFind; end;
  end;
end;

procedure TEDBGrid.DoEnter;
begin
  inherited DoEnter;
end;

function TEDBGrid.RecordCount :integer;
var mQ:Tquery;
    mSQL:string;
begin
  result:=-1;
  mQ:=Tquery.Create(Self);
  if (DataSource<>nil) and (DataSource.DataSet is TQuery) and (DataSource.DataSet.Active) then begin
    try
      mQ.DatabaseName:=Tquery(DataSource.DataSet).databaseName;
      mSQL:=Trim(SQL.text);
      SQLModify:='order';
      mQ.SQL.text:='select COUNT(*) as MXCntTatat from ('+SQL.text+') as TATAT';
      mQ.Params:=Tquery(DataSource.DataSet).Params;
      mQ.Open;
      Result:=mQ.FieldByName('MXCntTatat').asInteger;
      mQ.Close;
    finally
      mQ.free;
      SQL.text:=mSQL;
      SQLPase_m:=true;
    end;
  end;
end;

procedure TEDBGrid.MyClick1(sender:Tobject); // CTRL-C, copy to Clipboard
var mS,mR:string;
    i,j:integer;
    mB:TBookMark;
begin
  mS:='';
  if DataSource.DataSet<>nil then begin
    with DataSource.DataSet do begin
       if IsEmpty then exit;
       mS:='';
       Screen.Cursor:=crHourGlass;
       mB:=GetBookMark;
       DisableControls;
       if (SelectedRows.Count=0) or (Not (dgMultiSelect in Options))  then begin
         if dgRowSelect in Options then begin
            mR:='';
            for j:=0 to FieldCount-1 do begin
              if FieldCount=1 then mR:=mR+#9+Fields[j].asString;
              if (FieldCount>1) and (Fields[j].DataType in
                             [ftString, ftSmallint, ftInteger, ftWord, ftBoolean,
                              ftFloat, ftCurrency, ftDate, ftTime, ftDateTime, ftBytes,
                              ftVarBytes, ftAutoInc, ftFixedChar, ftWideString, ftLargeint])
             then mR:=mR+#9+Fields[j].asString;
            end;
            system.delete(mR,1,1);
            mS:=mS+mR;
         end else mS:=selectedField.asString;
       end else
       for i:=0 to SelectedRows.Count-1 do begin
          GotoBookmark(pointer(SelectedRows.Items[i]));
          mR:='';
          for j:=0 to FieldCount-1 do begin
            if FieldCount=1 then mR:=mR+#9+Fields[j].asString;
            if (FieldCount>1) and (Fields[j].DataType in
                           [ftString, ftSmallint, ftInteger, ftWord, ftBoolean,
                            ftFloat, ftCurrency, ftDate, ftTime, ftDateTime, ftBytes,
                            ftVarBytes, ftAutoInc, ftFixedChar, ftWideString, ftLargeint])
           then mR:=mR+#9+Fields[j].asString;
          end;
          system.delete(mR,1,1);
          mS:=mS+mR+#13#10;
       end;
       Clipboard.AsText:=mS;
       if mB<>nil then begin
         GotoBookMark(mB);
         freeBookMark(mB);
       end;
       EnableControls;
       Screen.Cursor:=crDefault;
     end;
  end;
end;

procedure TEDBGrid.SelectAll;
begin
  MyClick2(self);
end;

procedure TEDBGrid.MyClick2(sender:Tobject); // CTRL-A, vybrat vsetko
var mB:TBookMark;
begin
  if DataSource.DataSet<>nil then begin
    with DataSource.DataSet do begin
      if IsEmpty then exit;
      Screen.Cursor:=crHourGlass;
      mB:=GetBookMark;
      DisableControls;
      First;
      while Not eof do begin
        SelectedRows.CurrentRowSelected:=true;
        Next;
      end;
      GotoBookMark(mB);
      freeBookMark(mB);
      EnableControls;
      Screen.Cursor:=crDefault;
    end;
  end;
end;

procedure TEDBGrid.Unselect;
begin
   SelectedRows.Clear;
end;

procedure TEDBGrid.MyClick3(sender:Tobject); // CTRL-Z, opacny vyber
var mB:TbookMark;
begin
  if DataSource.DataSet<>nil then begin
    with DataSource.DataSet do begin
      if IsEmpty then exit;
      Screen.Cursor:=crHourGlass;
      mB:=GetBookMark;
      DisableControls;
      First;
      while Not eof do begin
        SelectedRows.CurrentRowSelected:=Not SelectedRows.CurrentRowSelected;
        Next;
      end;
      GotoBookMark(mB);
      freeBookMark(mB);
      EnableControls;
      Screen.Cursor:=crDefault;
    end;
  end;
end;


procedure TEDBGrid.MyClick4(sender:Tobject);  // view SQL
    function DelphiRunning : boolean;
    var
      H3, H4 : Hwnd;
    const
      A3 : array[0..18] of char = 'TPropertyInspector'#0;
      A4 : array[0..11] of char = 'TAppBuilder'#0;
    begin
      H3:=0; H4:=0;
      if H3=0 then H3 := FindWindow(A3, nil);
      if H4=0 then H4 := FindWindow(A4, nil);
      Result := (H3 <> 0) or (H4 <> 0);
    end;
var mS:string;
begin
  if fShowSQL or DelphiRunning then begin
    if (DataSource<>nil) and (DataSource.DataSet is TQuery) then begin
      mS:=Execute_DB_SQL_view(Tquery(DataSource.DataSet).SQL.text);
      if mS<>'' then begin
        Tquery(DataSource.DataSet).Close;
        Tquery(DataSource.DataSet).SQL.text:=mS;
        Tquery(DataSource.DataSet).Open;
      end;
    end;
  end;
end;

procedure TEDBGrid.MyClick5(Sender:Tobject);  // CTRL-F; Find
var X,Y:integer;
begin
  if fGridFilter<>nil then begin
    TEFilter(fGridFilter).Vyber;
    Exit;
  end;
  if (DataSource<>nil) and (DataSource.DataSet<>nil) then begin
    if Not (dgEditing in Options) then begin
      if (fOrder[1]=0) then begin
        MessageDlg('Najprv vyberte pole pre triedenie',mtWarning,[mbOk],0);
        exit;
      end;
//      if (SelectedRows.Count=1) and (SelectedRows.CurrentRowSelected) then SelectedRows.CurrentRowSelected:=false;
      if OrderFieldCount>0 then begin
        CreateFind;
        X:=Self.ClientOrigin.X-TForm(Self.Owner).ClientOrigin.X;
        Y:=Self.ClientOrigin.Y-TForm(Self.Owner).ClientOrigin.Y;
        Flabel.Left:=X+5;
        FLabel.Caption:=fOrderTitle;
        Fedit.Left:=X+5+fLabel.Width;
        FEdit.Top:=Y+1;fLabel.Top:=Y+2;
        fLabel.Visible:=true;
        fEdit.Visible:=true;
      //PostMessage(fEdit.Handle,WM_CHAR,byte(fKey),0);
        fEdit.SetFocus;
      end;
    end;
  end;
end;

procedure TEDBGrid.MyClick6(Sender:Tobject);  // CTRL-R; Refresh
begin
  try
    if (DataSource<>nil) and (DataSource.DataSet<>nil) then begin
      Screen.Cursor:=crHourGlass;
//    if (SelectedRows.Count=1) and SelectedRows.CurrentRowSelected then SelectedRows.CurrentRowSelected:=false;
      DataSource.DataSet.DisableControls;
      DataSource.DataSet.Active:=false;
      DataSource.DataSet.Active:=true;
      DataSource.DataSet.EnableControls;
    end else MessageDlg('DataSource.DataSet is nil',mtError,[mbOk],0)
  finally
    Screen.Cursor:=crDefault;
  end;
end;

function TEDBGrid.GetSelectFieldVal(pFieldName:string):string;
var i:integer;
    mB:TBookMark;
    mStr:boolean;
begin
  result:='';
  if DataSource.DataSet<>nil then begin
    if (SelectedRows.Count=0) then exit;
  //  if (SelectedRows.Count=1) and (SelectedRows.CurrentRowSelected) and (DataSource.DataSet.RecordCount>1) then exit;
    with DataSource.DataSet do begin
       result:='';
       if FindField(pFieldName)=nil then exit;
       mStr:=FindField(pFieldName).DataType in [ftString,ftBoolean,ftDate, ftTime,
                                                ftDateTime, ftBytes, ftVarBytes,
                                                ftMemo,ftFmtMemo,ftFixedChar,
                                                ftWideString,ftADT, ftArray,
                                                ftReference, ftDataSet];
       Screen.Cursor:=crHourGlass;
       mB:=GetBookMark;
       DisableControls;
       for i:=0 to SelectedRows.Count-1 do begin
          GotoBookmark(pointer(SelectedRows.Items[i]));
          if mStr then
            Result:=Result+','+#39+FieldByName(pFieldName).asString+#39
          else
            Result:=Result+','+FieldByName(pFieldName).asString;
       end;
       if Result<>'' then system.delete(Result,1,1);
       if mB<>nil then begin
         GotoBookMark(mB);
         freeBookMark(mB);
       end;
       EnableControls;
       Screen.Cursor:=crDefault;
     end;
  end;
end;

procedure TEDBGrid.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent=fGridFilter) then fGridFilter:=nil;
End;

procedure TEDBGrid.UMEditClose(var Msg: TMessage);
begin
  fLabel.Visible:=false;
  fEdit.text:='';
  fEdit.Visible:=false;
  Flabel.Free; FLabel:=nil;
  FEdit.Free; Fedit:=nil;
end;

procedure TEDBGrid.UMAkce(var Msg: TMessage);
begin
  Application.ProcessMessages;
  Refresh;
  fPost:=false;
end;

procedure TEDBGrid.UMPrior(var Msg: TMessage);
begin
  fDisableTitle:=true;
  if fMouseDown then begin
    while (fY=0) and (not DataSource.DataSet.Bof) do begin
      DataSource.DataSet.Prior ;
      if not DataSource.DataSet.Bof then if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
      Application.ProcessMessages;
    end;
  end;
end;

procedure TEDBGrid.UMNext(var Msg: TMessage);
begin
  if fMouseDown then begin
    while (fY=-1) and (not DataSource.DataSet.Eof) do begin
      DataSource.DataSet.Next ;
      if not DataSource.DataSet.Eof then if fsel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
      Application.ProcessMessages;
    end;
  end;
end;

procedure TEDBGrid.MyFind;
begin
  if (DataSource<>nil) and (DataSource.DataSet<>nil) then begin
    if fEdit=nil then exit;
    if FEdit.Visible=false then exit;
    if FEdit.text='' then exit;
    Screen.Cursor:=crHourGlass;
    DataSource.DataSet.DisableControls;
    try
      if DataSource.DataSet.Locate(fOrderName,fEdit.text,[loCaseInsensitive, loPartialKey]) then
          SelectedRows.CurrentRowSelected:=true;
    finally
      Screen.Cursor:=crDefault;
      DataSource.DataSet.EnableControls;
    end;
  end;
end;

procedure TEDBGrid.KeyDown(var Key: Word;Shift: TShiftState);
begin
  if (SelectedRows.Count<1) then fHist:='XXX';
  if (DataSource<>nil) and (DataSource.DataSet<>nil) then begin
   if ((Shift=[ssCtrl]) or (Shift=[])) and (key=13) and fEnterSelect then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
   if (Shift=[ssShift]) then begin
      fSel:=(dgMultiSelect in Options);
      if (Key=Vk_Up) then begin
        Key:=0;
        if fHist[3]<>'N' then
          if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
        if not DataSource.DataSet.Bof then begin
          DataSource.DataSet.Prior;
          AddHist('P');
        end;
        exit;
      end;
      if  (Key=Vk_Down) then begin
        Key:=0;
        if fHist[3]<>'P' then
          if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
        if not DataSource.DataSet.Eof then begin
          DataSource.DataSet.Next;
          AddHist('N');
        end;
        exit;
      end;
    end;
    if (Shift=[ssCtrl]) then begin
      if (Key=Vk_Up) then begin
        Key:=0;
        if not DataSource.DataSet.Bof then DataSource.DataSet.Prior;
        exit;
      end;
      if  (Key=Vk_Down) then begin
        Key:=0;
        if not DataSource.DataSet.Eof then DataSource.DataSet.Next;
        exit;
      end;
      if  (Key=Byte('C')) then begin
        MyClick1(self);
        Key:=0;
        exit;
      end;
      if  (Key=Byte('F')) then begin
        if OrderFieldCount>0 then begin
          MyClick5(self);
          Key:=0;
          exit;
        end;
      end;
      if dgMultiSelect in Options then begin
        if (Key=Byte('A')) then begin
          MyClick2(self);
          Key:=0;
          exit;
        end;
        if (Key=Byte('Z')) then begin
          MyClick3(self);
          Key:=0;
          exit;
        end;
      end;
      if (Key=VK_F11) then begin
        MyClick4(self);
        Key:=0;
        exit;
      end;
    end;
  end;
  inherited KeyDown(Key,Shift);
end;

procedure TEDBGrid.DblClick;
begin
  if fY<=0 then exit; // sme na title;
  fDblClick:=true;
  fMouseDown:=false;
  inherited DblClick;
  fUp:=false;
end;

procedure TEDBGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y:
Integer);
var mB:boolean;
    mX:integer;
    //mA:array of integer;
    //mCnt,i:integer;
begin
  if (SelectedRows.Count<1) then fHist:='XXX';
  mB:=true;  fDblClick:=false;
  if Assigned(fMDB) then fMDB(self,Button,Shift,mB,X, Y); {OnMouseDown-Before}
  if Button=mbLeft then begin
    fMouseDown:=true;
    fY:=MouseCoord(X, Y).Y; fOldY:=fY; fOldOldY:=-100;
    mX:=MouseCoord(X, Y).X; fX:=mX;
    if (fY<=0) or (mX<0) then fMouseDown:=false;
  end;
  if mB and (Button<>mbRight) then begin
    (*
    mCnt:=SelectedRows.Count;
    if (not fMouseMoveSelect) and (mCnt>0) then begin
      SetLength(mA,mCnt);
      for i:=0 to mCnt-1 do mA[i]:=integer(SelectedRows.Items[i]);
    end;
    *)
    if (ssCtrl in Shift) and (SelectedRows.Count=0) then
        SelectedRows.CurrentRowSelected:=Not SelectedRows.CurrentRowSelected;
    inherited MouseDown(Button,Shift,X,Y);
    (*
    if (not fMouseMoveSelect) and (mCnt>0) then begin
      for i:=0 to mCnt-1 do begin
        Tquery(DataSource.DataSet).GotoBookMark(TbookMark(mA[i]));
        SelectedRows.CurrentRowSelected:=true;
      end;
    end;
    *)
  end;
  if Assigned(fMDA) then fMDA(self,Button,Shift,X, Y); {OnMouseDown-After}
  if Button=mbRight then begin
    inherited MouseDown(mbLeft,[ssCtrl],X,Y);
    SelectedRows.CurrentRowSelected:=true;
   if PopupMenu<>nil then begin
      if fNewItem0<>nil then PopupMenu.Items.Remove(fNewItem0);
      if fNewItem1<>nil then PopupMenu.Items.Remove(fNewItem1);
      if fNewItem2<>nil then PopupMenu.Items.Remove(fNewItem2);
      if fNewItem3<>nil then PopupMenu.Items.Remove(fNewItem3);
      if fNewItem4<>nil then PopupMenu.Items.Remove(fNewItem4);
      if fNewItem5<>nil then PopupMenu.Items.Remove(fNewItem5);
      if fNewItem6<>nil then PopupMenu.Items.Remove(fNewItem6);

      fNewItem0:=TmenuItem.Create(Self.Owner);
      fNewItem0.Caption:='-';
      PopupMenu.Items.add(fNewItem0);

      fNewItem1:=TmenuItem.Create(Self.Owner);
      if fLang=l_English then fNewItem1.Caption:='Copy to clipboard' else
        fNewItem1.Caption:='Vloi do schrnky';
      fNewItem1.OnClick:=MyClick1;
      fNewItem1.ShortCut:=ShortCut(Word('C'), [ssCtrl]);
      PopupMenu.Items.add(fNewItem1);
      if dgMultiSelect in Options then begin
        fNewItem2:=TmenuItem.Create(Self.Owner);
        if fLang =l_English then fNewItem2.Caption:='Select all' else fNewItem2.Caption:='Vybra vetko';
        fNewItem2.OnClick:=MyClick2;
        fNewItem2.ShortCut:=ShortCut(Word('A'), [ssCtrl]);
        PopupMenu.Items.add(fNewItem2);

        fNewItem3:=TmenuItem.Create(Self.Owner);
        if fLang=l_English then fNewItem3.Caption:='Opposite select' else fNewItem3.Caption:='Opan vber';
        fNewItem3.OnClick:=MyClick3;
        fNewItem3.ShortCut:=ShortCut(Word('Z'), [ssCtrl]);
        PopupMenu.Items.add(fNewItem3);
      end;
      fNewItem5:=TmenuItem.Create(Self.Owner);
      if fLang=l_English then fNewItem5.Caption:='Find' else fNewItem5.Caption:='Vyhadvanie';
      fNewItem5.OnClick:=MyClick5;
      fNewItem5.ShortCut:=ShortCut(Word('F'), [ssCtrl]);
      PopupMenu.Items.add(fNewItem5);
      if OrderFieldCount<1 then fNewItem5.Enabled:=false;

      fNewItem6:=TmenuItem.Create(Self.Owner);
      if fLang=l_English then fNewItem6.Caption:='Refresh' else fNewItem6.Caption:='Obnovi daje';
      fNewItem6.OnClick:=MyClick6;
      fNewItem6.ShortCut:=ShortCut(Word('R'), [ssCtrl]);
      PopupMenu.Items.add(fNewItem6);

      fNewItem4:=TmenuItem.Create(Self.Owner);
      fNewItem4.Caption:='SQL';
      fNewItem4.OnClick:=MyClick4;
      fNewItem4.ShortCut:=ShortCut(VK_F11, [ssCtrl]);
      PopupMenu.Items.add(fNewItem4);
    end;
  end;
end;

procedure TEDBGrid.KeyUp(var Key: Word;Shift: TShiftState);
begin
  inherited KeyUp(key,Shift);
end;

procedure TEDBGrid.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  fMouseDown:=false;
  inherited MouseUp(Button,Shift,X, Y);
  fDisableTitle:=false;
  if fDblClick then begin
    if fSel or (dgAlwaysShowSelection in Options) then SelectedRows.CurrentRowSelected:=true;
    fUp:=false;
  end else begin
    if (SelectedRows.Count=1) and (Shift=[]) then begin
      if (fYUp=MouseCoord(X, Y).Y)  then begin
        if fSel then SelectedRows.CurrentRowSelected:=fUp;
        fUp:=Not (fUp);
      end else begin
        fUp:=true;
        if fSel then SelectedRows.CurrentRowSelected:=false;
      end;
    end;
  end;
  fYUp:=MouseCoord(X, Y).Y;
  fDblClick:=false;
end;

procedure TEDBGrid.MouseMove(Shift: TShiftState; X,Y: Integer);
begin
  inherited MouseMove(Shift,X,Y);
  fSel:=(dgMultiSelect in Options);
  if Not fMouseMoveSelect then begin
    if fMouseDown then fY:=MouseCoord(X, Y).Y;
    fOldY:=fY;
    Exit;
  end;
  if fMouseDown then begin
    fY:=MouseCoord(X, Y).Y;
    if (fY>0) and (fOldY>0) then begin
      if fY<>fOldY then begin
        if (fY>fOldY) then if not DataSource.DataSet.Eof then addHist('N');
        if (fY<fOldY) then if not DataSource.DataSet.Bof then addHist('P');
        if (fHist='NNP') or (fHist='PPN') then
          if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
        if (fY>fOldY) then if not DataSource.DataSet.Eof then DataSource.DataSet.Next;
        if (fY<fOldY) then if not DataSource.DataSet.Bof then DataSource.DataSet.Prior;
        if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
      end;
    end else begin
      if fY<>fOldY then begin
        if fY=-1 then begin
          addHist('N');
          if (fHist='NNP') or (fHist='PPN') then
            if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
          PostMessage(Handle, UM_Next, 0, 0);
        end;
        if (fY=0) then begin
          addHist('P');
          if (fHist='NNP') or (fHist='PPN') then
            if fSel then SelectedRows.CurrentRowSelected:=Not(SelectedRows.CurrentRowSelected);
          PostMessage(Handle, UM_Prior, 0, 0);
        end;
      end;
    end;
  end ;//else fHist:='XXX';
  fOldY:=fY;
end;

procedure TEDBGrid.addHist(pC:string);
begin
  if (length(fHist)<3) or (SelectedRows.Count<1) then fHist:='XXX';
  fHist:=fHist+pC;
  system.delete(fHist,1,1);
end;

function TEDBGrid.GetHist:string;
begin
  result:=fHist;
end;

procedure TEDBGrid.TitleClick(Column: TColumn);
begin
  if fDisableTitle then exit;
  if  fX>=width-10 then exit;
  inherited TitleClick(Column);
  ReOrder(Column);
  fColumnMoved:=false;
end;

procedure TEDBGrid.ColumnMoved(FromIndex,ToIndex: Integer);
begin
  fColumnMoved:=true;
  inherited ColumnMoved(FromIndex,ToIndex);
end;

procedure TEDBGrid.ReOrder(Column:TColumn);
var mS:string;
    i,mC:integer;
    mW:array[0..300] of Integer;
    mQ:Tquery;
begin
  if fColumnMoved then begin fColumnMoved:=false; exit;end;
  fColumnMoved:=false;
  if Column.Field=nil then exit;
  if fOrderCnt=0 then exit;
  mS:='';
  if Not (DataSource.DataSet is TQuery) then exit;

  SQL.text:=TQuery(DataSource.DataSet).SQL.text;
  Parse(oSQL.text);
  if fOrder[1]=Column.Field.FieldNo then
    fOrderDESC[1]:=Not fOrderDESC[1]
  else begin
    for i:=fOrderCnt downto 2 do begin
      fOrder[i]:=fOrder[i-1];
      if fOrder[i]=Column.Field.FieldNo then fOrder[i]:=0;
      fOrderDesc[i]:=fOrderDesc[i-1];
    end;
    fOrder[1]:= Column.Field.FieldNo;
    fOrderDesc[1]:=false;
  end;
  fOrderTitle:=Column.Title.Caption;
  fOrderName:=Column.Field.FieldName;
  for i:=1 to fOrderCnt do
    if fOrder[i]>0 then begin
      mS:=mS+','+IntToStr(fOrder[i]);
      if fOrderDESC[i] then mS:=mS+' DESC';
    end;
  if mS<>'' then system.delete(mS,1,1);
  SQLModify:='order by '+mS;
  //SaveColumWidth;
  mC:=Columns.Count;
  for i:=0 to mC-1 do begin
    mW[i]:=Columns.Items[i].Width;
    Columns.Items[i].Title.Font.style:=Columns.Items[i].Title.Font.style-[fsUnderline];
  end;
  Column.Title.Font.style:=Column.Title.Font.style+[fsUnderLine];
  if (SelectedRows.Count=1) and SelectedRows.CurrentRowSelected then SelectedRows.CurrentRowSelected:=false;
  Screen.Cursor:=crHourGlass;
  try
    mQ:=Tquery.Create(self);
    mQ.DatabaseName:=TQuery(DataSource.DataSet).dataBaseName;
    mQ.SQL.text:=TQuery(DataSource.DataSet).SQL.text;
    mQ.Params:=TQuery(DataSource.DataSet).Params;
    Tquery(DataSource.DataSet).DisableControls;
    TQuery(DataSource.DataSet).SQL.Clear;
    TQuery(DataSource.DataSet).SQL.Text:=SQL.Text;
    TQuery(DataSource.DataSet).Params:=mQ.Params;
    TQuery(DataSource.DataSet).Active:=true;
    mQ.Free;
  finally
    Tquery(DataSource.DataSet).EnableControls;
    Screen.Cursor:=crDefault;
    for i:=0 to mC-1 do Columns.Items[i].Width:=mW[i];
    if fGridFilter<>nil then TEFilter(fGridFilter).Edit2Refresh;
  end;
end;

procedure TEDBGrid.DrawIndex(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
  var A:integer;
var i,j,k:integer;
    mS,mA,mT:String;
begin
  fColumn:=Column; fRect:=Rect;
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
//   [csLoading, csReading, csWriting, csDestroying, csDesigning,csAncestor, csUpdating,csFixups, csInline]
  if Assigned(fDraw) then fDraw(self,Rect,DataCol,Column,State);
  if gdFocused in State then begin
    if fSel then begin
      if SelectedRows.CurrentRowSelected then Canvas.Brush.Color:=clRed
      else Canvas.Brush.Color:=clYellow;
    end else Canvas.Brush.Color:=clYellow;
  end;
  if Column.Field=nil then exit;
  // indexi pri starte
  //SendMessage(Handle, UM_AKCE2, 0, 0); {caka na odpoved}
  if (fOrder[1]=-1) and (dataSource<>nil) and (DataSource.DataSet<>nil) then begin
    fOrder[1]:=0;
    SQL.text:=Tquery(DataSource.DataSet).SQL.text;
    Parse(oSQL.text);
    mS:=GetSQLSegment('order');
    while Pos('  ',mS)>0 do delete(mS,Pos('  ',mS),1); // odstranenie dvojitych medzier
    if Length(mS)>9 then delete(mS,1,9);
    while pos(#13#10,mS)>0 do begin i:=Pos(#13#10,mS); delete(mS,i,1); mS[i]:=' '; end;
    while Pos('  ',mS)>0 do delete(mS,Pos('  ',mS),1); // odstranenie dvojitych medzier
    while Pos(', ',mS)>0 do delete(mS,Pos(', ',mS)+1,1);
    while Pos(' ,',mS)>0 do delete(mS,Pos(' ,',mS),1);
    mS:=trim(mS);
    if fGridFilter<>nil then begin
      if Trim(oFlds.text)='' then CreateFieldList;
      if mS<>'' then begin
        mS:=mS+','; k:=0;
        while (Pos(',',mS)>0) and (k<10) do begin
          i:=Pos(',',mS); inc(k);
          mT:=copy(mS,1,i-1);
          delete(mS,1,i); mA:='A';
          if Pos(' ',mT)>0 then begin
            mA:=AnsiUpperCase(copy(mT,Pos(' ',mT)+1,255));
            mT:=copy(mT,1,Pos(' ',mT)-1);
          end;
          if mT[1] in ['1'..'9'] then begin
            j:=StrToInt(mT);
          end else j:=StrToInt(GetFieldName(mT,ff_sql,ff_no));
          fOrder[k]:=j;
          fOrderDESC[k]:=mA[1]='D';
        end;
      end;
    end;
    if (mS<>'') and (fOrderedFields<>'') and (fGridFilter=nil) then begin
      mS:=fOrderedFields;
      if mS[Length(mS)]<>',' then mS:=mS+',';
      i:=Pos(',',mS); j:=1;
      while (i>0) and (j<10) do begin
        k:=StrToInt(Trim(copy(mS,1,i-1)));
        fOrder[j]:=Abs(k);
        fOrderDESC[j]:=k<0;
        inc(j);
        system.delete(mS,1,i);
        i:=Pos(',',mS);
      end;
    end;
    if (dataSource<>nil) and (DataSource.DataSet<>nil) then begin
      if fOrder[1]>0 then begin
        fOrderName:=getFieldName(IntToStr(fOrder[1]),ff_No,ff_dataset);
        fOrderTitle:=getFieldName(IntToStr(fOrder[1]),ff_No,ff_title);
        if fGridFilter<>nil then begin
          TEFilter(fGridFilter).Edit2Refresh;
          if Trim(TEFilter(fGridFilter).text)<>'' then TEFilter(fGridFilter).execute;
          if Assigned(fOKGrid) then fOKGrid(self);
          exit;
        end;
      end;
    end;
  end;
  if (fOrderCnt>=1) and (fOrder[1]=Column.Field.FieldNo)  then begin
    A:=Canvas.TextWidth(Column.Field.DisplayLabel);
    if Rect.Right-Rect.Left-A-16<0 then exit;
    with Canvas do begin
      if Not fOrderDESC[1] then begin
        Pen.Color:=clWindow;
        MoveTo(Rect.Right-4,10);
        LineTo(Rect.Right-16,10);
        LineTo(Rect.Right-10,4);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-4,10);
      end else begin
        Pen.Color:=clWindow;
        MoveTo(Rect.Right-4,4);
        LineTo(Rect.Right-16,4);
        LineTo(Rect.Right-10,10);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-4,4);
      end;
    end;
  end;
  if (fOrderCnt>=2) and (fOrder[2]=Column.Field.FieldNO)  then begin
    A:=Canvas.TextWidth(Column.Field.DisplayLabel);
    if Rect.Right-Rect.Left-A-14<0 then exit;
    with Canvas do begin
      if Not fOrderDESC[2] then begin
        Pen.Color:=clBtnShadow;
        MoveTo(Rect.Right-5,8);
        LineTo(Rect.Right-13,8);
        LineTo(Rect.Right-9,4);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-5,8);
      end else begin
        Pen.Color:=clBtnShadow;
        MoveTo(Rect.Right-5,4);
        LineTo(Rect.Right-13,4);
        LineTo(Rect.Right-9,8);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-5,4);
      end;
    end;
  end;
  if (fOrderCnt>=3) and (fOrder[3]=Column.Field.FieldNo)  then begin
    A:=Canvas.TextWidth(Column.Field.DisplayLabel);
    if Rect.Right-Rect.Left-A-14<0 then exit;
    with Canvas do begin
      if Not fOrderDESC[2] then begin
        Pen.Color:=clBtnShadow;
        MoveTo(Rect.Right-7,8);
        LineTo(Rect.Right-11,8);
        LineTo(Rect.Right-9,4);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-7,8);
      end else begin
        Pen.Color:=clBtnShadow;
        MoveTo(Rect.Right-7,4);
        LineTo(Rect.Right-11,4);
        LineTo(Rect.Right-9,8);
        Pen.Color:=clBtnShadow;
        LineTo(Rect.Right-7,4);
      end;
    end;
  end;
  if not fPost then begin
    PostMessage(Handle, UM_AKCE, 0, 0); {necaka na odpoved}
    // posielame udalost aby po vyktresleni cells urobil Refresh
    fPost:=true;
  end;
end;


// Nasleduju procedury pre SQL Parse
procedure TEDBGrid.SetParse(pB:boolean);
begin
  oParse:=pB;
  if pB then Parse(oSQL.text);
  oParse:=false;
end;

procedure TEDBGrid.SetChange(pS:String);
begin
  oChange:=pS;
  ChangeSQL(oChange);
  oChange:=''; {read only}
end;

procedure TEDBGrid.SetSQL(Value:TStringList);
var i:integer;
begin
  // tato procedura sa vyvola iba DesigTime v ObjectInspektorem
  for i:=Value.Count-1 downto 0 do if Trim(Value.Strings[i])='' then Value.delete(i);
  oSQL.Assign(Value);
  oOldSQL:='';
  Parse(oSQL.text);
end;

procedure TEDBGrid.SetSyntax(Value:TStringList);
var i:integer;
begin
  if oSyntax<>Value then oSyntax.Assign(Value);
  for i:=oSyntax.Count-1 downto 0 do oSyntax.Strings[i]:=TRIM(AnsiUpperCase(oSyntax.Strings[i]));
  for i:=oSyntax.Count-1 downto 0 do if oSyntax.Strings[i]='' then oSyntax.delete(i);
end;

procedure TEDBGrid.Parse(pS:String);   //SQL parse
var
    mS:String;
    i,j,k,mA:integer;
    mB,mC:boolean;
begin
  if oNotParse then exit;
  if Trim(pS)='' then begin
    oOldSQL:='';
    for i:=1 to 20 do begin oWords[i].A:=0; oWords[i].B:=0;end;
    exit;
  end;
  if oOldSQL=pS then exit;  // netreba vykonat uz bola vykonana
  oOldSQL:=pS;
  for i:=oSyntax.Count-1 downto 0 do oSyntax.Strings[i]:=TRIM(AnsiUpperCase(oSyntax.Strings[i]));
  for i:=oSyntax.Count-1 downto 0 do if oSyntax.Strings[i]='' then oSyntax.delete(i);
  for i:=0 to oSyntax.Count-1 do oWords[i+1].W:=oSyntax.Strings[i];
  for i:=1 to 20 do begin oWords[i].A:=0; oWords[i].B:=0;end;
  mS:=AnsiUpperCase(pS);
  mA:=0; mB:=false; mC:=false;
  for i:=1 to length(pS)-1 do begin
    if (not (mB or mC)) and (mS[i]='(') then inc(mA);
    if (not (mB or mC)) and (mS[i]=')') then dec(mA);
    if (not mC) and (mS[i]='"') then mB:=not(mB);
    if (not mB) and (mS[i]=#39) then mC:=not(mC);
    if (mA=0) and (not mB) and (not mC) then begin
      if oWords[1].A=0 then begin
        if Length(mS)>=i+length(oWords[1].W) then begin
          if (oWords[1].W=copy(mS,i,length(oWords[1].W))) and (mS[i+length(oWords[1].W)] in [' ',#13]) then oWords[1].A:=i;
        end;
      end else begin
        for j:=2 to oSyntax.Count do begin
          if oWords[j].A=0 then begin
            if length(mS)>=i+length(oWords[j].W) then begin
              if (oWords[j].W=copy(mS,i,length(oWords[j].W))) and (mS[i+length(oWords[j].W)] in [' ',#13]) then begin
                oWords[j].A:=i;
                for k:=j-1 downto 1 do if (oWords[k].A>0) and (oWords[k].A<i) and (oWords[k].B=0) then oWords[k].B:=i-1;
                Break;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
  for k:=oSyntax.Count downto 1 do if (oWords[k].A>0) and (oWords[k].A<length(mS)) and (oWords[k].B=0) then oWords[k].B:=length(pS);
End;

function TEDBGrid.GetSQLSegment(pKeyWord:string):string; // vrati segment SQL dotazu

  Function Spaces2To1(pS:string):String;
  begin
    while Pos('  ',pS)>0 do System.Delete(pS,Pos('  ',pS),1);
    Result:=pS;
  End;


  function Normal(pT:String):String;
  var h:integer;
  begin
    Result:=Spaces2To1(pT);
    h:=Pos(#13#10,pT);
    while h>0 do begin
      delete(pT,h,2);
      h:=Pos(#13#10,pT);
    end;
  end;

  var i:integer;
      mKey:byte;
begin
  Result:=''; mKey:=0;
  pKeyWord:=Trim(AnsiUpperCase(pKeyWord));
  for i:=1 to oSyntax.Count do begin
    if Trim(oWords[i].W)=pKeyWord then begin mKey:=i;Break; end;
  end;
  if mKey=0 then exit;
  if oWords[mKey].A>0 then begin
    Result:=Trim(ABcopy(oSQL.text,oWords[mKey].A,oWords[mKey].B));
    Result:=Normal(Result);
  end;
end;

procedure TEDBGrid.ChangeSQL(pSegment:string);
const cD=240;
var i,j,mA,mKey,mI:integer;
    mT,mS,mKeyWord:string;
    mB,mC:boolean;
begin
  if oWords[1].W='' then Parse(oSQL.text);
  oOldSQL:='';
  pSegment:=Trim(pSegment);
  if (length(pSegment)>cD) then begin
   // rozlamanie pSegment na max. cD dlhe riadky
    mA:=0; mB:=false; mC:=false; mI:=0;
    for i:=1 to length(pSegment) do begin
      inc(mI);
      if (not (mB or mC)) and (pSegment[i]='(') then inc(mA);
      if (not (mB or mC)) and (pSegment[i]=')') then dec(mA);
      if (not mC) and (pSegment[i]='"') then mB:=not(mB);
      if (not mB) and (pSegment[i]=#39) then mC:=not(mC);
      if (mA=0) and (not mB) and (not mC) then begin
        if (mI>5) and ((pSegment[i]=' ') or (pSegment[i]=',')) then begin
          if pSegment[i]=',' then mS:=mS+','+#13#10 else mS:=mS+' '+#13#10;
          mI:=0;
        end else mS:=mS+pSegment[i];
      end else mS:=mS+pSegment[i];
    end;
    // mS je teraz uplne rozlamany
    // ideme viazat riadky do dlzky cD
    j:=Pos(#13#10,mS); mT:=''; pSegment:='';
    if j=0 then j:=length(mS)+1;
    while (j>0) and (Length(mS)>0) do begin
      if length(mT)+Length(copy(mS,1,j-1))<=cD then mT:=mT+copy(mS,1,j-1)
      else begin
        pSegment:=pSegment+mT+#13#10;
        mT:=copy(mS,1,j-1);
      end;
      delete(mS,1,j+1);
      j:=Pos(#13#10,mS);
      if j=0 then j:=length(mS)+1;
    end;
    pSegment:=pSegment+mT+#13#10;
  end;
  mKey:=0;
  j:=Pos(' ',pSegment); if j=0 then j:=Pos(#13,pSegment); if j>10 then j:=0;
  if j=0 then mKeyWord:=Trim(AnsiUpperCase(pSegment)) else mKeyWord:=Trim(AnsiUpperCase(copy(pSegment,1,j)));
  for i:=1 to oSyntax.Count do begin
    if Trim(oWords[i].W)=mKeyWord then begin mKey:=i;Break; end;
  end;
  if mKey=0 then exit;  // neexistujuci segment error
  if j=0 then begin   // treba segment vymazat
    if oWords[mKey].A>0 then begin // ak segment exituje tak odstranime
      mS:=oSQL.Text;
      delete(mS,oWords[mKey].A,oWords[mKey].B -oWords[mKey].A+1);
      while Pos(#13#10#13#10,mS)>0 do delete(mS,Pos(#13#10#13#10,mS),2);
      oSQL.text:=mS;
    end;
  end else begin
    if oWords[mKey].A=0 then AddSegment(mKeyWord,pSegment) // treba segment pridat
    else begin
      mS:=oSQL.Text;   // treba segment prepisat
      if oWords[mKey].A-1>1 then mT:=copy(mS,1,oWords[mKey].A-1) else mT:='';
      mS:=copy(mS,oWords[mKey].B+1,length(oSQL.text));
      if mT<>'' then mT:=mT+#13#10;
      mS:=mT+pSegment+#13#10+mS;
      while Pos(#13#10#13#10,mS)>0 do delete(mS,Pos(#13#10#13#10,mS),2);
      oSQL.Text:=mS;
    end;
  end;
  Parse(oSQL.text);
End;

procedure TEDBGrid.AddSegment(pKeyWord,pSegment:string);
var i,mKey:integer;
    mS:String;
begin
  mKey:=0;
  for i:=0 to oSyntax.Count-1 do begin
    if oSyntax.Strings[i]=pKeyWord then begin mKey:=i; break; end;
  end;
  if mKey=0 then exit;
  for i:=mKey downto 1 do begin
    if (oWords[i].B)>0 then begin
      mS:=oSQL.text;
      insert(#13#10+pSegment+#13#10,mS,oWords[i].B+1);
      while Pos(#13#10#13#10,mS)>0 do delete(mS,Pos(#13#10#13#10,mS),2);
      oSQL.text:=mS;
      break;
    end;
  end;
End;

function  TEDBGrid.NextPos(pPos:integer;pVal,pS:string):integer;
var mT:string;
    i:integer;
begin
  Result:=0;
  if pPos>length(pS) then exit;
  mT:=copy(pS,pPos,length(pS));
  i:=Pos(pVal,mT);
  if i>0 then Result:=pPos-1+i;
end;

Function TEDBGrid.ABCopy(pS:String; pA,pB:longint):String;
begin
  Result:='';
  if pB<pA then Exit;
  if Length(pS)<=pA then Exit;
  Result:=copy(pS,pA,pB-pA+1);
End;

function TEDBGrid.Zatvorka(pA:integer; pS:string):integer;
var i,mOt:integer;
    mB:boolean;
begin
  Result:=0;
  i:=pA;
  mOt:=1;
  mB:=false;
  while i<length(pS) do begin
    inc(i);
    if pS[i] in [#39,'"'] then mB:=not mB;
    if not mB then begin
      if pS[i]='(' then inc(mOt);
      if pS[i]=')' then dec(mOt);
    end;
    if mOt=0 then begin Result:=i; exit; end;
  end;
end;

function TEDBgrid.GetTableNames:string;
var mSL:TStringList;
    mS:String;
    i: integer;
    position: integer;
begin
  mSL := TStringList.Create;
  mS:=TQuery(DataSource.DataSet).DataBaseName;
  Session.GetTableNames(mS, '*', false,false, mSL);
  for i:=0 to mSL.Count-1 do
  begin
    position:=Pos('.',mSL[i]);
    while Position>0 do begin
      mSL[i]:=Copy(mSL[i],position+1,Length(mSL[i]));
      position:=Pos('.',mSL[i]);
    end;
  end;
  result:=AnsiUpperCase(mSL.text);
  mSL.Free;
end;

procedure TEDBGrid.CreateFieldList;
var mS,mTab,mT,mA,mB,mX,mTitle:String;
    mTable:TQuery;
    mQ,mQQ:Tquery;
    mS1,mS2:TStringList;
    i,j,k:integer;
    mF:TField;
begin
  //if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
  if DataSource=nil then exit;
  if DataSource.DataSet=nil then exit;
  if NOT (DataSource.DataSet is TQuery) then exit;
  oFlds.Clear;
  if trim(SQL.text)='' then begin
    SQL.text:=TQuery(DataSource.DataSet).SQL.text;
    Parse(oSQL.text);
  end;
  mS:=AnsiUpperCase(Trim(GetSQLSegment('from')));
  if mS='' then begin beep; exit; end;
  delete(mS,1,5);
  mS:=mS+' ';
  // tu vytvorit na cesto alias a to pozit a odstranit cestu
  mTab:=#13#10+GetTableNames+#13#10;
  mTable:=TQuery.Create(self);
  mQ  := TQuery.Create(self);
  mS1 := TStringList.Create;
  mS2 := TStringList.Create;
  mS1.Clear;
  mS2.Clear;
  try
    mTable.DataBaseName:=TQuery(DataSource.DataSet).DataBaseName;
    while pos(#13#10,mS)>0 do begin i:=Pos(#13#10,mS); delete(mS,i,1); mS[i]:=' '; end;
    while Pos(' AS ',mS)>0 do delete(mS,Pos(' AS ',mS),3);
    while Pos('  ',mS)>0 do delete(mS,Pos('  ',mS),1); // odstranenie dvojitych medzier
    while Pos(', ',mS)>0 do delete(mS,Pos(', ',mS)+1,1);
    while Pos(' ,',mS)>0 do delete(mS,Pos(' ,',mS),1);
    while Pos('\ ',mS)>0 do delete(mS,Pos('\ ',mS)+1,1);
    while Pos(' \',mS)>0 do delete(mS,Pos(' \',mS),1);
    i:=-1; j:=NextPos(i+2,',',mS);// pred ciarkami dame medzeru
    while j>0 do begin insert(' ',mS,j); i:=j; j:=NextPos(i+2,',',mS); end;
    while Pos(' ',mS)>0 do begin
      i:=Pos(' ',mS); k:=0; mA:='';
      mT:=trim(copy(mS,1,i-1));
      // odstanime cestu k tabulke ak obsahuje  napr: C:\ab\table.dbf
      while Pos('\',mT)>0 do delete(mT,1,Pos('\',mT));
      while Pos(':',mT)>0 do delete(mT,1,Pos(':',mT));
      while Pos('(',mT)>0 do delete(mT,1,Pos('(',mT));
      while Pos(')',mT)>0 do delete(mT,1,Pos(')',mT));
      // odstanime extension z nazvu tabulky ak existuje
      while Pos('.',mT)>0 do delete(mT,Pos('.',mT),255);
      mT:=trim(mT);
      if Pos(',',mT)=1 then delete(mT,1,1);
      if Pos(';'+mT+';',';CROSS;NATURA;KEY;OUTER;FULL;INNER;JOIN;LEFT;RIGHT;ON;')>0 then begin delete(mS,1,i); continue; end;
      if mT<>'' then begin
        if i>0 then begin
          k:=NextPos(i+1,' ',mS);
          if k>0 then mA:=Trim(ABcopy(mS,i+1,k-1));
        end;
        if (mA='') or (Pos(',',mA)=1) or (mA='ON') or (Pos(';'+mA+';',';CROSS;NATURA;KEY;OUTER;FULL;INNER;JOIN;LEFT;RIGHT;ON;')>0) then begin
          k:=0; mA:='';
        end;
        if Pos(#10+mT+#13,mTab)>0 then begin
          mTable.sql.clear;
          mTable.sql.add('select * from '+mT);//TableName:=mT;
          mS1.Clear;
          mTable.GetFieldNames(mS1);
          for j:=0 to mS1.Count-1 do
          mS2.add(AnsiUpperCase(';'+mA+'.'+mS1.Strings[j]+';'+mT+'.'+mS1.Strings[j]+';'));
        end else k:=0;
      end;
      if k<i then delete(mS,1,i) else  delete(mS,1,k);
    end;
    mS:=AnsiUpperCase(Trim(GetSQLSegment('select')));
    delete(mS,1,6); mS:=trim(mS)+',';
    while pos(#13#10,mS)>0 do begin i:=Pos(#13#10,mS); delete(mS,i,1); mS[i]:=' '; end;
    while Pos(' AS ',mS)>0 do delete(mS,Pos(' AS ',mS),3);
    while Pos('  ',mS)>0 do delete(mS,Pos('  ',mS),1); // odstranenie dvojitych medzier
    while Pos(', ',mS)>0 do delete(mS,Pos(', ',mS)+1,1);
    while Pos(' ,',mS)>0 do delete(mS,Pos(' ,',mS),1);
    while Pos(',',mS)>0 do begin
      mT:=Copy(mS,1,Pos(',',mS)-1);
      delete(mS,1,Pos(',',mS));
      i:=Pos('(',mT);
      if i>0 then begin
        j:=Zatvorka(i,mT);
        delete(mT,i,j-i+1);
        mT:=trim(mT);
      end;
      mA:='';
      if Pos(' ',mT)>0 then begin
        mA:=Trim(copy(mT,Pos(' ',mT)+1,255));
        mT:=Trim(copy(mT,1,Pos(' ',mT)-1));
      end;
      if mT='*' then for i:=0 to mS2.Count-1 do oFlds.Add(mS2.Strings[i]);
      if Pos('.*',mT)>1 then begin
        mB:=trim(copy(mT,1,Pos('.*',mT)-1));
        for i:=0 to mS2.Count-1 do begin
          if Pos(';'+mB+'.',mS2.Strings[i])>0 then begin
            oFlds.Add(mS2.Strings[i]);
          end;
        end;
      end;
      if mA<>'' then begin
        for i:=0 to mS2.Count-1 do begin
          if Pos('.',mT)=0 then begin
            if Pos(';.'+mT+';',mS2.Strings[i])>0 then begin
              oFlds.Add(';'+mA+';'); break;
            end else begin
              if Pos('.'+mT+';',mS2.Strings[i])>0 then begin
                oFlds.Add(';'+mA+';'); break;
              end;
            end;
          end else begin
            if Pos(';'+mT+';',mS2.Strings[i])>0 then begin
              oFlds.Add(';'+mT+';;'+mA+';'); break;
            end;
          end;
        end;
      end else begin
        if (Pos('*',mT)=0) then begin
          for i:=0 to mS2.Count-1 do begin
            if Pos('.',mT)=0 then begin
              if Pos(';.'+mT+';',mS2.Strings[i])>0 then begin
                oFlds.Add(mS2.Strings[i]); break;
              end else begin
                if Pos('.'+mT+';',mS2.Strings[i])>0 then begin
                  oFlds.Add(mS2.Strings[i]); break;
                end;
              end;
            end else begin
              if Pos(';'+mT+';',mS2.Strings[i])>0 then begin
                oFlds.Add(mS2.Strings[i]); break;
              end;
            end;
          end;
        end;
      end;
    end;
  finally
    mQQ:=TQuery(DataSource.DataSet);
    mQ.DataBaseName:=TQuery(DataSource.DataSet).DataBaseName;
    mQ.SQL.text:=Tquery(DataSource.DataSet).SQL.text;
    mQ.Params:=Tquery(DataSource.DataSet).Params;
    //mQ:=TQuery(DataSource.DataSet);
    mS1.Clear;
    try
      mQ.GetFieldNames(mS1);
      if oFlds.Count>=mS1.Count then begin
        for i:=0 to mS1.Count-1 do begin
          //if (i+1) mod 20=0 then Application.processmessages;
          mA:=mS1.Strings[i];
          mB:='>'+AnsiUpperCase(mA)+'<';
          mF:=mQQ.FindField(mA);
          if (mF<>nil) and (mF.Visible) then mB:=mB+'#'+ mF.DisplayLabel+'#'
          else mB:=mB+'#'+mA+'#';
          for j:=0 to Columns.Count-1 do begin
            if Columns[j].FieldName=mA then begin
              if Columns[j].Visible then mB:=mB+'@'+Columns[j].Title.Caption+'@';
              Break;
            end;
          end;
          oFlds.Strings[i]:=oFlds.Strings[i]+mB;
        end;
      end;
    finally
      for i:=0 to fAddFields.Count-1 do begin
        mS:=Trim(fAddFields.Strings[i]);
        mTitle:='';
        if Pos(' ',mS)>0 then begin
          mTitle:=Trim(copy(mS,Pos(' ',mS)+1,255));
          mS:=Trim(copy(mS,1,Pos(' ',mS)-1));
        end;
        if Trim(mS)='' then continue;
        if Pos('.',mS)>0 then begin
          mT:=copy(mS,Pos('.',mS)+1,255);
          mX:=mS;
        end else begin
          mT:=mS;
          mX:='.'+mS;
        end;
        if mTitle='' then mTitle:=mT;
        oFlds.add(';'+AnsiUpperCase(mX)+';'+AnsiUppercase(mS)+';>'+AnsiUppercase(mT)+'<#'+mTitle+'#@'+mTitle+'@');
      end;
      mQ.Free;
      mTable.Free;
      mS1.Free;
      mS2.Free;
    end;
  end;
end;

procedure TEDBGrid.SetFlds(pF:TStringList);
begin
  oFlds.Clear;
  oFlds.text:=pF.text;
end;

procedure TEDBGrid.RefreshFieldList;
begin
 if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
 CreateFieldList;
end;

function TEDBGrid.GetFieldName(pName:string; pFrom,pTo:T_MyFieldType):string;
  function GetIndex(pName:string):integer;
  var j,i:integer;
  begin
    Result:=-1;
    for i:=0 to oFlds.Count-1 do begin
      if pName[1] in ['#','@'] then j:=Pos(pName,AnsiUpperCase(oFlds.Strings[i]))
      else j:=Pos(pName,oFlds.Strings[i]);
      if j>0 then begin Result:=i; exit;end;
    end;
  end;

  Function GetSQLFieldName(i:integer):string;    //Alias.Field or Table.Field
  var mS:String;
  begin
    Result:='';
    mS:=copy(oFlds.Strings[i],2,500);
    if mS[1]='.' then delete(mS,1,Pos(';',mS));
    Result:=Copy(mS,1,Pos(';',mS)-1);
  end;

  function GetSQLTableFieldName(i:integer):string;   // Table.Field
  var mS:String;
  begin
    Result:='';
    mS:=copy(oFlds.Strings[i],2,500);
    delete(mS,1,Pos(';',mS));
    Result:=Copy(mS,1,Pos(';',mS)-1);
  end;

  function GetTitleFieldName(i:integer):string;
  var mS:String;
      j:integer;
  begin
     Result:='';
     mS:=oFlds.Strings[i];
     j:=Pos('@',mS);
     if j>0 then begin
       mS:=Copy(mS,j+1,255);
       Result:=Copy(mS,1,Pos('@',mS)-1);
     end else begin
       j:=Pos('#',mS);
       if j>0 then begin
         mS:=Copy(mS,j+1,255);
         Result:=Copy(mS,1,Pos('#',mS)-1);
       end;
     end;
  end;
  function GetDataSetFieldName(i:integer):string;
  var mS:String;
      j:integer;
  begin
     Result:='';
     mS:=oFlds.Strings[i];
     j:=Pos('>',mS);
     if j>0 then begin
       mS:=Copy(mS,j+1,255);
       Result:=Copy(mS,1,Pos('<',mS)-1);
     end;
  end;

var i:integer;
    mS:String;
begin
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
   i:=-1; Result:='';
   mS:=AnsiUpperCase(Trim(pName));
   if mS='' then exit;
   if mS[1] in [#39,'"'] then delete(mS,1,1);
   if mS[length(mS)] in [#39,'"'] then delete(mS,Length(mS),1);
   if oFlds.Count=0 then CreateFieldList;
   if pFrom=pTo then begin Result:=pName; exit; end;
   case pFrom of
   ff_sql,ff_sqltable: begin
       if Pos('.',pName)=0 then mS:='.'+mS;
       i:=GetIndex(';'+mS+';');
       if (i=-1) and (Pos('.',pName)=0) then begin
         mS:=AnsiUpperCase(Trim(pName));
         i:=GetIndex(';'+mS+';');
       end;
     end;
   ff_dataset: i:=GetIndex('>'+mS+'<');
   ff_title: begin i:=GetIndex('@'+mS+'@'); if i=-1 then i:=GetIndex('#'+mS+'#'); end;
   ff_no: begin
       i:=StrToInt(pName);
       i:=i-1; if i<0 then exit;
       if i>oFlds.Count then i:=0;
     end;
   end;
   if i=-1 then exit;
   Case pTo of
   ff_sql:     Result:=GetSQLFieldName(i);
   ff_sqltable:Result:=GetSQLTableFieldName(i);
   ff_dataset: Result:=GetDataSetFieldName(i);
   ff_title:   Result:=GetTitleFieldName(i);
   ff_no:      Result:=IntToStr(i+1);
   end;
end;

procedure TEDBGrid.SetAddToWhere(pS:String);
var mS:String;
    i:integer;
begin
  if trim(pS)='' then exit;
  mS:=TrimLeft(GetSQLSegment('where'));
  if Trim(mS)<>'' then begin
    i:=Pos(' ',mS); if (i=0) or (i>6) then i:=6;
    insert('(',mS,i+1);
    mS:=mS+') and '+pS;
  end else mS:='where '+ pS;
  SQLModify:=mS;
  oAddToWhere:='';
end;
(*
procedure TEDBGrid.DeleteFromWhere(pS:String);
// tato procedura je urcena iba pre odstanenie casi Where segmentu ktora bola pridana SQLAddToWhere:=segment sposobom
var mS:String;
    i:integer;
begin
  if trim(pS)='' then exit;
  mS:=Trim(GetSQLSegment('where'));
  delete(mS,1,5);
  mS:=trim(mS);
  pS:=Trim(pS);
  i:=Pos(pS,mS); if i=0 then exit;
  delete(mS,i,Length(pS));
  mS:=trim(mS);
  if length(mS)>3 then begin
    if AnsiUpperCase(Copy(mS,Length(mS)-2,3))='AND' then begin
      delete(mS,Length(mS)-2,3);
      mS:=trim(mS);
      if length(mS)>1 then begin
        if (mS[1]='(') and (mS[length(mS)]=')') then begin
          delete(mS,1,1); delete(mS,Length(mS),1);
          mS:=trim(mS);
        end;
      end;
    end;
  end;
  mS:=Trim('where '+mS);
  SQLModify:=mS;
end;
*)

procedure TEDBGrid.DeleteFromWhere(pS:String);
// tato procedura je urcena iba pre odstanenie casi Where segmentu ktora bola pridana SQLAddToWhere:=segment sposobom
var mS:String;
    i:integer;
begin
  if trim(pS)='' then exit;
  mS:=Trim(GetSQLSegment('where'));
  delete(mS,1,5);
  mS:=trim(mS);
  pS:=Trim(pS);
  i:=Pos(UpperCase(') and '+pS),UpperCase(mS));
  if i>0 then begin
    if i>0 then delete(mS,i,Length(') and '+pS));
    if pos('(',mS)>0 then delete(mS,Pos('(',mS),1);
  end else begin
    i:=Pos(UpperCase(' and '+pS),UpperCase(mS));
    if i>0 then begin
      if i>0 then delete(mS,i,Length(' and '+pS));
    end else begin
      i:=Pos(UpperCase(pS),UpperCase(mS));
      if i>0 then delete(mS,i,Length(pS));
    end;
  end;
  mS:=trim(mS);
  if Pos('() AND ',UpperCase(mS))=1 then delete(mS,1,length('() and '));
  if Pos('( ) AND ',UpperCase(mS))=1 then delete(mS,1,length('( ) and '));
  if Pos('()',mS)=1 then delete(mS,1,length('()'));
  if Pos('( )',mS)=1 then delete(mS,1,length('( )'));
  mS:=Trim('where '+Trim(mS));
  SQLModify:=mS;
  AcceptSQL(true);
end;

procedure TEDBGrid.SetParseQuery(pB:boolean);
begin
  if DataSource=nil then exit;
  if DataSource.DataSet=nil then exit;
  if NOT (DataSource.DataSet is TQuery) then exit;
  oParseQuery:=pB;
  if pB then SQL.text:=TQuery(DataSource.DataSet).SQL.text;
  Parse(SQL.text);
  oParseQuery:=false;
end;

function TEDBGrid.GetOrderTitleName:string;
begin
  Result:=fOrderTitle;
end;

procedure TEFilter.setCaptions;
begin
  with fNewItemA do begin
    if (fGrid<>nil) and (fGrid.fLang=l_English) then caption:='Select field' else Caption:='Vber poloky';
  end;
  with fNewItemB do begin
    Caption:='-';
  end;
  with fNewItem0 do begin
    if (fGrid<>nil) and (fGrid.fLang=l_English) then caption:='begines with text (zlike)' else Caption:='zana textom (zlike)';
  end;
  with fNewItem1 do begin
    if (fGrid<>nil) and (fGrid.fLang=l_English) then caption:='includes text (like)' else Caption:='obsahuje text (like)';
  end;
  with fNewItem2 do begin
    if fGrid.fLang=l_English then caption:='more or equal (>=)' else Caption:='v alebo sa rovn sa  (>=)';
  end;
  with fNewItem3 do begin
    if fGrid.fLang=l_English then caption:='less or equal(<=)' else Caption:='men alebo sa rovn  (<=)';
  end;
  with fNewItem4 do begin
    if fGrid.fLang=l_English then caption:='equal (=)' else Caption:='rovn sa  (=)';
  end;
  with fNewItem5 do begin
    if fGrid.fLang=l_English then caption:='not includes text (not like)' else Caption:='neobsahuje text  (not like)';
  end;
  with fNewItem6 do begin
    if fGrid.fLang=l_English then caption:='un equal' else Caption:='nerovn sa  (<>)';
  end;
  with fNewItem7 do begin
    Caption:='-';
  end;
  with fNewItem8 do begin
    if fGrid.fLang=l_English then caption:='Use compac index' else Caption:='Pouva viazan filter';
  end;
end;

procedure TEFilter.StartPopUp(sender:TObject);
begin
  Setcaptions;
  case fRelType of
  f_Begines: fNewItem0.Checked:=true;
  f_Includes: fNewItem1.Checked:=true;
  f_MoreEq: fNewItem2.Checked:=true;
  f_LessEq: fNewItem3.Checked:=true;
  f_Eq:   fNewItem4.Checked:=true;
  f_NotIn: fNewItem5.Checked:=true;
  f_UnEq: fNewItem6.Checked:=true;
  end;
end;

constructor TEFilter.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fActive:=true;
  Height:=44;
  Width:=290;
  fDefRel:='>='; // default
  fRelType:=f_MoreEq;
  fEdit1:=TEdit.Create(self);
  fEdit2:=TEdit.Create(self);
  fButton:=TButton.Create(self);
  if (Self.ComponentState =[csFreeNotification]) or  (Self.ComponentState=[]) then begin
      fPop:=TPopupMenu.Create(self);
      fPop.OnPopup:=StartPopUp;
      PopupMenu:=fPop;
      fNewItemA:=TmenuItem.Create(Self);
      with fNewItemA do begin
        caption:='Select field';
        RadioItem:=false;
        OnClick:=MyClickA;
      end;
      fNewItemB:=TmenuItem.Create(Self);
      with fNewItemB do begin
        Caption:='-';
      end;
      fNewItem0:=TmenuItem.Create(Self);
      with fNewItem0 do begin
        caption:='begines with text (zlike)';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem1:=TmenuItem.Create(Self);
      with fNewItem1 do begin
        caption:='includes text (like)';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem2:=TmenuItem.Create(Self);
      with fNewItem2 do begin
        caption:='more or equal (>=)';
        RadioItem:=true;
        Checked:=true;
        OnClick:=MyClick1;
      end;
      fNewItem3:=TmenuItem.Create(Self);
      with fNewItem3 do begin
        caption:='less or equal(<=)';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem4:=TmenuItem.Create(Self);
      with fNewItem4 do begin
        caption:='equal (=)';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem5:=TmenuItem.Create(Self);
      with fNewItem5 do begin
        caption:='not includes text (not like)';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem6:=TmenuItem.Create(Self);
      with fNewItem6 do begin
        caption:='un equal';
        RadioItem:=true;
        OnClick:=MyClick1;
      end;
      fNewItem7:=TmenuItem.Create(Self);
      with fNewItem7 do begin
        Caption:='-';
      end;
      fNewItem8:=TmenuItem.Create(Self);
      with fNewItem8 do begin
        caption:='Use compac index';
        RadioItem:=false;
        OnClick:=MyClick2;
      end;
     fPop.Items.add(fNewItemA);
     fPop.Items.add(fNewItemB);
     fPop.Items.add(fNewItem0);
     fPop.Items.add(fNewItem1);
     fPop.Items.add(fNewItem2);
     fPop.Items.add(fNewItem3);
     fPop.Items.add(fNewItem4);
     fPop.Items.add(fNewItem5);
     fPop.Items.add(fNewItem6);
     fPop.Items.add(fNewItem7);
     fPop.Items.add(fNewItem8);
  end;

  with fButton do begin
    Parent:=self;
    Caption:='Filter';
    left:= 0;
    Top:= 1;
    Height:=fEdit2.height;
    Width:= 70;
    OnClick:=ButtonClick;
  end;
  with fEdit2 do begin
    Parent:=self;
    left:= 72;
    top:=fButton.top;
    width:=Self.width-fButton.Left-fButton.Width-2 ;
    Color:=clBtnFace;
    Ctl3D:=false;
    ReadOnly:=true;
    TabStop:=false;
    text:='';
    OnChange:=Edit2Change;
  end;
  with fEdit1 do begin
    Parent:=self;
    left:= 0;
    top:=fEdit2.top+fEdit2.Height;
    width:=Self.width;
    Color:=clWindow;
    text:='';
    Font.Style:=[fsBold];
    Font.Color:=clNavy;
    AutoSelect:=false;
    OnDblClick:=Edit1DblClick;
    OnKeyPress:=Edit1KeyPress;
    OnChange:=Edit1Change;
    OnKeyDown:=Edit1KeyDown;
  end;
  Height:=fEdit1.top+fEdit1.Height;
end;

Destructor TEFilter.Destroy;
begin
  PopupMenu:=nil;
  if fNewItem1<>nil then begin
    fNewItemA.Free;
    fNewItemB.Free;
    fNewItem0.Free;
    fNewItem1.Free;
    fNewItem2.Free;
    fNewItem3.Free;
    fNewItem4.Free;
    fNewItem5.Free;
    fNewItem6.Free;
    fNewItem7.Free;
    fNewItem8.Free;
  end;
  if fPop<>nil then fPop.Free;
  fedit1.Free;
  fEdit2.Free;
  fButton.Free;
  inherited Destroy;
end;

procedure TEFilter.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent=fGrid) then fGrid:=nil;
end;

procedure TEFilter.MyClickA(sender:TObject);
begin
  ButtonClick(sender);
end;

procedure TEFilter.MyClick1(sender:TObject);
var mRel:T_ERelation;
begin
  mRel:=fRelType;
  TMenuItem(sender).Checked:=true;
  fDefRel:=TMenuItem(sender).Caption;
  fDefRel:=copy(fDefRel,Pos('(',fDefRel),255);
  delete(fDefRel,Pos('(',fDefRel),1);
  delete(fDefRel,Pos(')',fDefRel),1);
  fDefRel:=trim(fDefRel);
  case fDefRel[1] of
  'l': fRelType:=f_Includes;
  '>': fRelType:=f_MoreEq;
  '<': if fDefRel[2]='>' then fRelType:=f_UnEq else fRelType:=f_LessEq;
  '=': fRelType:=f_EQ;
  'n': fRelType:=f_NotIN;
  'z': fRelType:=f_Begines;
  end;
  if Pos('like',fDefRel)>0 then fDefRel:=' '+fDefRel+' ';
  Edit2Refresh;
  if mRel<>fRelType then Execute;
end;

procedure TEFilter.MyClick2(sender:TObject);
begin
  TMenuItem(sender).Checked:=not TMenuItem(sender).Checked;
  if TMenuItem(sender).Checked then fViazat:=true else fViazat:=false;
end;

procedure TEFilter.Vyber;
begin
  fEdit1.SetFocus;
end;

procedure TEFilter.SetGrid(pG:TEDBGrid);
begin
  if pG=nil then fGrid:=nil
  else begin
    if pG is TEDBGrid then begin
      fGrid:=pG;
      fGrid.SeTEFilter(TPanel(Self));
    end else MessageDlg('Only TEDbGrid',mtError,[mbOk],0);
  end;
end;

procedure TEFilter.MyResize;
begin
  Self.Caption:='';
  with fButton do begin
    Caption:='Filter';
    left:=0;
    Top:=1;
    Height:=fEdit2.height;
    Width:=70;
  end;
  with fEdit2 do begin
    left:=72;
    top:=fButton.top;
    width:=Self.width-fButton.Left-fButton.Width -2;
    Color:=clBtnFace;
    ReadOnly:=true;
    TabStop:=false;
  end;
  with fEdit1 do begin
    left:=0;
    top:=fEdit2.top+fEdit2.Height;
    width:=Self.width ;
    Color:=clWindow;
  end;
  if fSingle then begin
    fButton.Visible:=false;
    fEdit2.Visible:=false;
    fEdit1.top := 0;
    fedit1.BringToFront;
  end else begin
    fedit1.SendToBack;
    Height:=fEdit1.top+fEdit1.Height;
  end;
end;

procedure TEFilter.Resize;
begin
  inherited resize;
  MyResize;
end;

procedure TEFilter.SetSingle(pB:boolean);
begin
  fSingle:=pB;
  if pB then Height:=fEdit1.Height;
  MyResize;
end;

procedure TEFilter.ButtonClick(sender:TObject);
var mT:TPoint;
    mS:String;
    mRel,mField:string;
    mAdd:boolean;
begin
  if fGrid=nil then exit;
  if (Sender is TPopupMenu) or (Sender is TMenuItem) then begin
    GetCursorPos(mT);
    mT.X:=mT.X;
    mT.Y:=mT.Y;
  end else begin
    mT.X:=fButton.ClientOrigin.x;
    mT.Y:=fButton.ClientOrigin.y+20;
  end;
  mS:=Execute_GridFields(mT,fGrid,fDefRel,((Trim(fEdit1.text)<>'') and (Not fSingle)));
  if mS='' then exit;
  mRel:=''; mField:='';
  mAdd:=Pos('++',mS)=1;
  if mAdd then delete(mS,1,2);
  mField:=copy(mS,1,Pos('::',mS)-1);
  mRel:=copy(mS,Pos('::',mS)+2,255);
  if not mAdd then begin
    fEdit1.text:='';
    fEdit2.text:='('+mField+')'+mRel+'?';
  end else begin
    fEdit1.text:=fEdit1.text+#255+'and'+#255;
    fEdit2.text:=fEdit2.text+' and ('+mField+')'+mRel+'?';
  end;
  fEdit1.SetFocus;
  fEdit1.SelStart:=Length(fEdit1.text);
end;

procedure TEFilter.Edit2Change(Sender: TObject);
var mS:String;
begin
  if Pos(#39,fEdit1.text)>0 then begin
    mS:=fEdit1.text;
    delete(mS,Pos(#39,mS),1);
    fEdit1.text:=mS;
  end;
  if Trim(fEdit2.text)='' then begin
    if fGrid<>nil then begin
      if TRim(fGrid.GetOrderTitleName)<>'' then
        fEdit2.text:='('+fGrid.GetOrderTitleName +')'+fDefRel+'?'
      else fEdit2.text:='';
    end;
  end;
  if fSingle then begin
    fedit1.Hint:='Filter: '+fedit2.text;
    fedit1.ShowHint:=true;
  end else fEdit1.ShowHint:=false;
end;

procedure TEFilter.Edit2Refresh;
begin
  if fGrid<>nil then begin
    if TRim(fGrid.GetOrderTitleName)<>'' then
      fEdit2.text:='('+fGrid.GetOrderTitleName+')'+fDefRel+'?'
    else fEdit2.text:='';
  end;
end;

procedure TEFilter.Edit1Change(Sender: TObject);
var mS:string;
begin
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
  if Trim(fEdit1.text)='' then begin
    exit;
    if fActive=false then exit;
    fEdit2.text:='';
    if fGrid<>nil then begin
      if (fGrid.DataSource<>nil) and (fGrid.DataSource.DataSet<>nil) then begin
        if fFilter<>'' then begin
          fGrid.DeleteFromWhere(fFilter);
          TQuery(fGrid.DataSource.dataSet).SQL.text:=fGrid.SQL.Text;
          TQuery(fGrid.DataSource.dataSet).Close;
          TQuery(fGrid.DataSource.dataSet).Open;
          if Assigned(fAfterFiltered) then fAfterFiltered(self);
        end;
      end;
    end;
    fFilter:='';
  end else begin
    if fActive=false then exit;
    if Trim(fEdit2.text)='' then begin
       ButtonClick(sender);
    end;
    mS:=Trim(fEdit1.text);
    if (Pos(#255,mS)>0) and (Pos(#255+'and',mS)=Length(mS)-3) then begin
      fEdit1.text:='';
      fFilter:='';
    end;
    if fFindChange and (Trim(fEdit1.text)<>'') then Dotaz;
  end;
end;

procedure TEFilter.Edit1DblClick(Sender: TObject);
var mK:char;
begin
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
  mK:=#13;
  Edit1KeyPress(Sender,mK);
end;

procedure TEFilter.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key=VK_Down then begin
    if fGrid<>nil then begin
      key:=0;
      if fFindChange then begin
        if Assigned(fEnter) then fEnter(self);
        fGrid.DataSource.Dataset.Next;
      end else begin
        Dotaz;
      end;
      fGrid.SetFocus;
    end;
  end;
  if key=VK_Up then begin
    if fGrid<>nil then begin
      key:=0;
      if fFindChange then begin
        if Assigned(fEnter) then fEnter(self);
        fGrid.DataSource.Dataset.Prior;
      end else begin
        Dotaz;
      end;
      fGrid.SetFocus;
    end;
  end;
end;

procedure TEFilter.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
  if key=#39 then key:=#0;
  if fFindChange then begin
    if Key=#13 then begin
      Key:=#0;
      if fExecute then Dotaz;
      if Assigned(fEnter) then fEnter(self);
    end;
  end else begin
    if Key=#13 then begin
      Key:=#0;
      if fGrid=nil then exit;
      Dotaz;
    end;
  end;
end;

procedure TEFilter.Dotaz;
var i,j:integer;
    mS,mT:string;
begin
    if fGrid=nil then exit;
    if (text=fOldText) and (text<>'') and (not fExecute) and TQuery(fGrid.DataSource.dataSet).Active then exit;
    fOldText:=text;
    with fGrid do begin
      if Trim(fedit1.text)='' then begin
        fEdit1.Color:=clWhite;
        if fFilter<>'' then DeleteFromWhere(fFilter);
        if (fGrid.DataSource<>nil) and (fGrid.DataSource.DataSet<>nil) then begin
          TQuery(fGrid.DataSource.dataSet).SQL.text:=fGrid.SQL.Text;
          TQuery(fGrid.DataSource.dataSet).Close;
          TQuery(fGrid.DataSource.dataSet).Open;
          if Assigned(fAfterFiltered) then fAfterFiltered(self);
        end;
        fFilter:='';
        fedit1.Hint:='Filter: '+fedit2.text;
        fOldFilter:='';
        Exit;
      end;
      if Trim(fEdit1.text)='' then begin
        fFilter:='';
        Self.Color:=clWhite;
        exit;
      end;
      mS:=fedit2.text;
      fEdit1.Color:=clYellow;
      ReplaceToSQLName(mS);
      while Pos('(',mS)>0 do delete(mS,Pos('(',mS),1);
      while Pos(')',mS)>0 do delete(mS,Pos(')',mS),1);
      i:=Pos('?',mS);
      mT:=fedit1.text+#255+'and'+#255;
      fFilter:='';j:=1;
      while (i>0) and (j>0) do begin
        j:=pos(#255+'and'+#255,mT);
        if (Pos(' LIKE ',copy(mS,1,i))>0) or (Pos(' ZLIKE ',copy(mS,1,i))>0) then begin
          if (Pos(' ZLIKE ',copy(mS,1,i))>0) then begin
             if Pos('<MEMO>',UpperCase(fEdit2.text))>0 then begin
               fFilter:=fFilter+copy(mS,1,i-1)+#39+copy(mT,1,j-1)+'%'+#39;
             end else begin
               fFilter:=fFilter+copy(mS,1,i-1)+'Upper('+#39+copy(mT,1,j-1)+'%'+#39+')';
             end;
          end else begin
            if Pos('<MEMO>',UpperCase(fEdit2.text))>0 then begin
               fFilter:=fFilter+copy(mS,1,i-1)+#39+'%'+copy(mT,1,j-1)+'%'+#39
            end else begin
               fFilter:=fFilter+copy(mS,1,i-1)+'Upper('+#39+'%'+copy(mT,1,j-1)+'%'+#39+')';
            end;
          end;
        end else fFilter:=fFilter+copy(mS,1,i-1)+#39+copy(mT,1,j-1)+#39;
        delete(mS,1,i);
        delete(mT,1,j+4);
        i:=Pos('?',mS);
      end;
      i:=Pos(' ZLIKE ',fFilter);
      while i>0 do begin
        if i>0 then begin delete(fFilter,i,7); insert(' LIKE ',fFilter,i); end;
        i:=Pos(' ZLIKE ',fFilter);
      end;
      if fViazat then begin fFilter:=Viazat(fFilter);
      end else begin
        i:=Pos(' LIKE',Ffilter);
        j:=Pos(' NOT LIKE',fFilter);
        if (j>0) and (j<i) then i:=j;
        if (i>1) and (Pos('<MEMO>',UpperCase(fEdit2.text))=0) then  begin
          Insert(')',fFilter,i);
          FFilter:='(Upper('+fFilter+')';
        end;
      end;
      if (fFilter=fOldFilter) and (not fExecute) then begin
        if TQuery(fGrid.DataSource.dataSet).Active=false then TQuery(fGrid.DataSource.dataSet).Open;
        exit;
      end;
      fExecute:=false;
      if fOldFilter<>'' then DeleteFromWhere(fOldFilter);
      fOldFilter:=fFilter;
      SQLAddToWhere:=fFilter;
      if fFilter='' then  fedit1.Hint:='Filter: '+fedit2.text else begin
        mS:=Copy(fedit2.text,1,Length(fEdit2.text)-1);
        mS:='Filter:'+mS+fEdit1.text;
        Hint:=mS;
        fEdit1.Hint:=mS;
      end;
      if (fGrid.DataSource<>nil) and (fGrid.DataSource.DataSet<>nil) then begin
        TQuery(fGrid.DataSource.dataSet).SQL.text:=fGrid.SQL.Text;
        TQuery(fGrid.DataSource.dataSet).Close;
        TQuery(fGrid.DataSource.dataSet).Open;
        if Assigned(fAfterFiltered) then fAfterFiltered(self);
      end;
    end;
end;

procedure TEFilter.ReplaceToSQLName(var pS:string);
var i,j:integer;
    mT:String;
begin
  pS:=AnsiUpperCase(pS);
  while pos('  ',pS)>0 do delete(pS,Pos('  ',pS),1);
  pS:=trim(pS);
  i:=Pos('(',pS);
  while i>0 do begin
    j:=Pos(')',pS);
    mT:=Copy(pS,i+1,(j-1)-(i+1)+1 );  //pA,  pB-pA+1
    mT:=fGrid.GetFieldName(mT,ff_title,ff_sql);
    delete(pS,i,j-i+1);
    insert(mT,pS,i);
    i:=Pos('(',pS);
  end;
end;

function TEFilter.Viazat(pS:string):string;
    function  NextPos(pPos:integer;pVal,pS:string):integer;
    var mT:string;
        i:integer;
    begin
      Result:=0;
      if pPos>length(pS) then exit;
      mT:=copy(pS,pPos,length(pS));
      i:=Pos(pVal,mT);
      if i>0 then Result:=pPos-1+i;
    end;

var i,j,k,h,mZ:integer;
    mT,mV:string;
begin
  pS:=pS+' ';
  Result:=pS;
  i:=Pos('>=',pS); mZ:=0;
  while (i>0) and (NextPos(i+1,' AND ',pS)>0) do begin
    k:=1;
    for j:=i downto 1 do if pS[j]=' ' then begin k:=j; Break; end;
    mT:=copy(pS,k,i-1-k+1); // nazov polozky
    j:=Pos(#39,pS);
    h:=NextPos(j+1,#39+' ',pS);
    mV:=copy(pS,j,h-j+1); // hodnota; za predpokladu ze hodnota neobsahuje #39
    delete(pS,k,h-k+1);
    insert(mT+'>'+mV+' or ('+mT+'='+mV,pS,k);
    inc(mZ); // pocet otvorenych zatvoriek
    i:=Pos('>=',pS);
  end;
  i:=Pos('<=',pS);
  while (i>0) and (NextPos(i+1,' AND ',pS)>0) do begin
    k:=1;
    for j:=i downto 1 do if pS[j]=' ' then begin k:=j; Break; end;
    mT:=copy(pS,k,i-1-k+1); // nazov polozky
    j:=Pos(#39+' ',pS);
    h:=NextPos(j+1,#39,pS);
    mV:=copy(pS,j,h-j+1); // hodnota; za predpokladu ze hodnota neobsahuje #39
    delete(pS,k,h-k+1);
    insert(mT+'<'+mV+' or ('+mT+'='+mV+' and ',pS,k);
    inc(mZ); // pocet otvorenych zatvoriek
    i:=Pos('<=',pS);
  end;
  for i:=1 to mZ do pS:=pS+')';
  Result:=pS;
end;

procedure TEFIlter.SetRelType(pRel:T_ERelation);
begin
  fRelType:=pRel;
  case fRelType of
  f_Begines : fDefRel:=' zlike ';
  f_Includes: fDefRel:=' like ';
  f_MoreEq: fDefRel:='>=';
  f_LessEq: fDefRel:='<=';
  f_Eq:   fDefRel:='=';
  f_NotIn: fDefRel:='<>';
  f_UnEq: fDefRel:=' not like ';
  end;
end;

procedure TEFilter.SetFocus;
begin
  fEdit1.SetFocus;
end;

procedure TEFilter.SelectAll;
begin
  fEdit1.SelectAll;
end;

procedure TEFilter.SelStart(pI:integer);
begin
  fEdit1.SelStart:=pI;
end;

function TEFilter.GetText:string;
begin
  Result:=fEdit1.text;
end;

procedure TEFilter.SetText(pS:String);
begin
  fEdit1.text:=pS;
end;

function TEFilter.GetText2:string;
begin
  Result:=fEdit2.text;
end;

procedure TEFilter.SetText2(pS:String);
begin
  fEdit2.text:=pS;
end;

procedure TEFilter.Execute;
var mK:char;
begin
  if (Self.ComponentState <> [csFreeNotification]) and (Self.ComponentState <> []) then exit;
  mK:=#13;
  fExecute:=true;
  Edit1KeyPress(Self,mK);
  fExecute:=false;
end;

function TEFilter.GetFocused:boolean ;
begin
  Result := fEdit1.Focused or fEdit2.Focused ;
end ;

procedure TEDBGrid.SetfCreateFlds(pB:boolean);
begin
  fCreateFlds:=pB;
  Screen.Cursor:=crHourGlass;
  try
    if pB then begin
      if (DataSource<>nil) and (DataSource.DataSet<>nil) and (DataSource.DataSet is TQuery) then begin
        if SQL.text<>TQuery(DataSource.DataSet).SQL.text then begin
          if SQL.Text='' then SQL.text:=TQuery(DataSource.DataSet).SQL.text
          else begin
            if MessageDlg('Do you want copy Query.SQL to SQL property?',mtWarning,[mbYes,mbNo],0)=mrYes then begin
               SQL.text:=TQuery(DataSource.DataSet).SQL.text;
            end;
          end;
        end;
        Parse(oSQL.text);
        CreateFieldList;  //toto je dolezite , zapise oFlds = Fields property
      end else ShowMessage('DataSource is not Query');
    end;
  finally
    fCreateFlds:=false;
    Screen.Cursor:=crDefault;
  end;
end;

procedure TEDBGrid.SetfAddFields(pS:TStringList);
var i:integer;
begin
  fAddFields.Clear;
  fAddFields.text:=pS.text;
  i:=fAddFields.Count-1;
  while i>0  do begin
    dec(i);
    if (Trim(fAddFields.Strings[i])='') then fAddFields.Delete(i);
  end;
end;

procedure Register;
begin
  RegisterComponents('Sample', [TEDBGrid,TEFilter]);
end;

end.


