unit uEDate;
(******************* EdDate*****************
 *  Autor: Tungli J. '97
 *  Edititacia datumu
 *  Hotkey F7-pre tvar dd,mm,rrrr, ked je prazdny tak F7 ja aktualny datum
 *  Nie je mozne opustit polozku, pokial datum nie je spravny alebo prazdny
 ********************************************)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask,uRozne;
type
  TEDate = class(TMaskEdit)
  private
    oFirstOldText:string;
    oInt        : Longint;
    oDate       : TDateTime;
    oEnterByTab : boolean;
    oOk         : boolean;
    oEmpty      : boolean;
    oEmptyDate  : string;
    oFontColor  : TColor;
    oldTime,oTime : TDateTime;
    oCnt          : integer;
    oArrowBy      : boolean;
    procedure SetEmpty(pB:boolean);
    procedure SetOk(pB:boolean);
    procedure SetDate(pD:TDateTime);
    procedure SetInt(pI:Longint);
  protected
    procedure DoExit;  override;
    procedure DoEnter; override;
    procedure Change;  override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key:char); override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property  IsEmpty     : boolean read oEmpty write SetEmpty;
    property  IsOk        : boolean read oOk write SetOK;
    property  EnterByTab  : boolean read oEnterByTab write oEnterByTab;
    property  AsDate      : TDateTime read oDate write SetDate;
    property  AsInteger   : Longint read oInt write SetInt;
    property  ArrowNoByTab : boolean read oArrowBy write oArrowBy;
    function  DateOk      : boolean;
    function  IsDateOk    : boolean;
  end;

(*procedure Register;*)

implementation

constructor TEDate.Create(AOwner: TComponent);
begin
  Inherited Create(AOwner);
  oEnterByTab:=true;
  EditMask:='!99/99/9999;1; ';
  oEmptyDate:=Text;
  oDate:=-999999;
  oInt:=0;
  width:=65;
End;

Procedure TEDate.KeyDown(var Key: Word; Shift: TShiftState);
var i:integer;
begin
  if (Key=vk_delete) and (ssCtrl in Shift) then Key:=0;
  if key=vk_F7 then begin
    i:=selStart;
    if (Text=oEmptyDate) or (Text='') then oEmpty:=true else oEmpty:=false;
    Text:=DateToStr(SysUtils.Date);
    if IsDateOk then;
    SelStart:=i;
  end;
  if not oArrowBy then begin
    if(Key = VK_Up) then begin		{ if it's an enter key }
      if Owner is TForm then begin
         Key := 0;			{ eat enter key }
        (Owner as Tform).Perform(WM_NEXTDLGCTL, 1, 0);     { move to next control }
        while (Owner as Tform).ActiveControl.Showing=false do (Owner as Tform).Perform(WM_NEXTDLGCTL, 1, 0);
      end;
    end;
    if(Key = VK_Down) then begin		{ if it's an enter key }
      if Owner is TForm then begin
         Key := 0;			{ eat enter key }
        (Owner as Tform).Perform(WM_NEXTDLGCTL, 0, 0);     { move to next control }
        while (Owner as Tform).ActiveControl.Showing=false do (Owner as Tform).Perform(WM_NEXTDLGCTL, 0, 0);
      end;
    end;
  end;
  inherited KeyDown(Key, Shift);
End;

procedure TEDate.KeyPress(var Key:char);
var mOwner:TForm;
begin
  if Key=#13 then oFirstOldText:=text;
  if Key=#27 then Text:=oFirstOldText;
  if Key=',' then Key:='.';
  if key='+' then begin
    oldTime:=oTime;
    oTime:=Time;
    if AbS(oTime-OldTime)<0.000001 then inc(oCnt) else oCnt:=0;
    if oInt=0 then oDate:=SysUtils.Date-1;
    if oCnt<4 then SetDate(AsDate+1) else SetDate(AsDate+15)
  end;
  if key='-' then begin
    oldTime:=oTime;
    oTime:=Time;
    if AbS(oTime-OldTime)<0.000001 then inc(oCnt) else oCnt:=0;
    if oInt=0 then oDate:=SysUtils.Date+1;
    if oCnt<4 then SetDate(AsDate-1) else SetDate(AsDate-15);
  end;
  if key='*' then text:='';
  if Key='/' then Text:=DateToStr(SysUtils.Date);
  if(Key = #13) and oEnterByTab then begin		{ if it's an enter key }
    if Owner is TForm then begin
      mOwner:=(Owner as Tform);
      Key := #0;			{ eat enter key }
      mOwner.Perform(WM_NEXTDLGCTL, 0, 0);     { move to next control }
    end;
  end;
  inherited KeyPress(key);
End;

procedure TEDate.Change;
var mS:String;
begin
  oOk:=false;
  mS:=Trim(Self.Text); mS:=DelSpaces(mS);
  if (mS=oEmptyDate) or
     (mS='') or
     (mS=DateSeparator+DateSeparator) or
     (mS=DateSeparator) or
     (mS='0'+DateSeparator+'0'+DateSeparator+'0000') then begin
    oEmpty:=true;
    Text:='  '+DateSeparator+'  '+DateSeparator;
    oDate:=-999999;oInt:=0;
  end else begin
    oEmpty:=false;
    if mS[1]='0' then delete(mS,1,1);
    if Pos(DateSeparator+'0',mS)<4 then delete(mS,Pos(DateSeparator+'0',mS)+1,1);
    if Length(DelSpaces(mS))>2 then begin
      //if Trim(system.Copy(mS, 7, 10))<>'' then begin
        oOk:=true;
        IsDateOk;
      //end else begin oDate:=-999999;oInt:=0; end;
    end else begin oDate:=-999999; oInt:=0; end;
  end;
  inherited Change;
End;

procedure TEDate.DoExit;
begin
  inherited DoExit;
  if IsDateOk=false then begin
    Self.SetFocus;selStart:=1;
  end else if oDate<>-999999 then Text:=DateToStr(oDate) else Text:=oEmptyDate;
end;

procedure TEDate.DoEnter;
begin
  oFirstOldText:=text;
  if Font.Color<>clRed then oFontColor := Font.Color else oFontColor:=clBlack;
  inherited DoEnter;
end;

procedure TEDate.SetDate(pD:TdateTime);
begin
// FieldByName('..').asDateTime z null hodnoty urony nulovu hodnotu a co odpoveda datumu 30.12.1899
// pre odstranenie nedostatku je dodany if pD=0 then pD=-999999;
  if pD=0 then pD:=-999999;
  if (pD<=-69000) then Text:='' else
  begin
    try Text:=DateToStr(pD); except end;
  end;
End;

procedure TEDate.SetInt(pI:Longint);
var DD,MM,RR:word;
    mD:TDateTime;
    mS:String;
begin
  if (pI<=10000101) or (pI>29991231) then begin oInt:=0;Text:='';exit;end;
  begin
    mS:=IntToStr(pI);
    RR:=StrToInt(copy(mS,1,4));
    if RR<1000 then RR:=1000;
    if RR>2999 then RR:=2999;
    MM:=StrToInt(copy(mS,5,2)); if (MM<1) or (MM>12) then MM:=1;
    DD:=StrToInt(copy(mS,7,2)); if (DD<1) or (DD>31) then DD:=1;
    mD:=EncodeDate(RR,MM,DD);
    try Text:=DateToStr(mD); except end;
  end;
End;

procedure TEDate.SetEmpty(pB:boolean);
begin  end;
procedure TEDate.SetOk(pB:boolean);
begin  end;

function TEDate.IsDateOk:boolean;
begin
  Result:=DateOk;
  if Result then Font.Color:=oFontColor else Font.Color:=clRed;
end;

function TEDate.DateOk: boolean;
var mDate:TDateTime;
    mS:String;
    mDD,mMM,mRR:string;
    RR,DD,MM,RR1,MM1,DD1:word;
    i,mErr:integer;
begin
  oDate:=-999999;oInt:=0;
  result := false; oOk:=false;
  mS:=Text; mS:=DelSpaces(mS);
  try
    if (mS=oEmptyDate) or (mS='') or (mS=DateSeparator+DateSeparator) or (mS=DateSeparator) then begin
      oEmpty:=true; Result:=true; oOK:=false;
      Exit;
    end;
    oEmpty:=false;
    if Length(mS)<3 then exit;
    if Pos(DateSeparator,mS)=0 then Exit
      else if Pos(DateSeparator,copy(mS,Pos(DateSeparator,mS)+1,255))=0 then exit;
    if pos(DateSeparator+'0'+DateSeparator,mS)>0 then exit;
    if pos(DateSeparator+'00'+DateSeparator,mS)>0 then exit;
    if pos(DateSeparator,mS)=1 then exit;
    if mS='' then exit;
    i:=pos(DateSeparator,mS); if i=0 then exit;
    mDD:=Trim(copy(mS,1,i-1));
    delete(mS,1,i);
    i:=pos(DateSeparator,mS); if i=0 then exit;
    mMM:=Trim(copy(mS,1,i-1));
    delete(mS,1,i);
    DecodeDate(Date,RR1,MM1,DD1); {zistime aktualne storocie}
    if mMM='' then mMM:=IntToStr(MM1);
    mRR:=Trim(mS);
    if mRR='' then mRR:=IntToStr(RR1);
    Val(mDD,DD,mErr); if mErr>0 then exit;
    Val(mMM,MM,mErr); if mErr>0 then exit;
    Val(mRR,RR,mErr); if mErr>0 then exit;
    if (DD<1) or (DD>31) then exit;
    if (MM<1) or (MM>12) then exit;
    if length(mRR)=2 then RR:=Trunc(100*Trunc(RR1/100)+0.1)+RR;
    if length(mRR)=1 then RR:=Trunc(10*Trunc(RR1/10)+0.1)+RR;
    if (RR<1) or (RR>9999) then exit;
    if DD>uRozne.DaysThisMonth(MM,RR) then Exit;
    oDate:=EncodeDate(RR,MM,DD);
    oInt:=RR*10000+MM*100+DD;
    Result:=true;
    oOK:=true;
  except
    result:=false; oOK:=false; Exit;
  end;
End;

(*
procedure Register;
begin
  RegisterComponents('Edge', [TEDate]);
end;
*)

END.
