unit uEFind;
(*
  Ryhle vyhladavanie nad SQL aj nad XBase datazazami.
  Kominuje SQL where a Locate funkcie
  Otvorenie velkeho mnoztva dat zabere vela casu. Toto riesi tato komponenta
  Query by mal byt order by FindFieldName
*)


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,stdctrls,uEStr,DB,DbTables,uRozne,uEQuery;

type
  TElisterSave=procedure (sender:Tobject; pQ:TQuery) of object;
  TEFind = class(TEStr)
  private
    fNewColor,fExistColor:Tcolor;
    fByAlias:boolean;
    fAfterChange:TNotifyEvent;
    fQ:TEQuery;
    fNewValue:Boolean;
    fField,fSQLField,fAliasField,fSQLAliasField:string;
    fActive:boolean;
    fOriginalSQL:string;
    fCount:byte;
    fLastChar:char;
    fNumToler:double;
    fEq:boolean;
    fValue:string; //pomocnea premenne
    fFirst:boolean;
    fWhere:string;
    fExit:boolean;

    procedure SetQuery(AQuery:TEQuery);
    procedure SetfAliasField(AFieldName:String);
    procedure SetfField(AFieldName:String);
    procedure SetfActive(AActive:Boolean);
    { Private declarations }
  protected
    procedure Change; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure  Notification(AComponent: TComponent; Operation: TOperation); override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
    property NewValue: boolean read fNewValue;
    property OriginalSQLText:string read fOriginalSQL;

    property FindFrom:byte read fCount write fCount;
    property FindLastChar:Char read FLastChar write fLastChar;
    property FindNumToler:double read fNumToler write fNumToler;
    property FindAliasFieldName: string read fAliasField write SetfAliasField;
    property FindSQLAliasFieldName:string read fSQLAliasField write fSQLAliasField;
    property FindFieldName: string read fField write SetfField;
    property FindSQLFieldName: string read fSQLField write fSQLField;
    property FindEq:boolean read fEq write fEq;
    property FindQuery:TEQuery read fQ write SetQuery;
    property FindActive:boolean read fActive write SetfActive;
    property FindByAliasField:boolean read fByAlias write fByAlias;
    property OnAfterChange: TNotifyEvent read fAfterChange write fAfterChange;

    procedure MyRefresh;
    function  MyFind(AValue:string):boolean;
   { Published declarations }
  end;

{procedure Register; }

implementation

constructor TEFind.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fExistColor:=clBlack;
  fNewColor:=clBlue;
  fCount:=0;
  fActive:=true;
  if fQ<>nil then fOriginalSQL:=fQ.sql.text;
  fFirst:=true;
  fLastChar:='z';
  fByAlias:=false;
End;

procedure TEFind.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent=fQ) then fQ:=nil;
End;

procedure TEFind.SetQuery(AQuery:TEQuery);
begin
  fQ:=AQuery;
  fOriginalSQL:=fQ.SQL.text;
  fValue:='';
end;

procedure TEFind.SetfAliasField(AFieldName:String);
var i:integer;
    mS:String;
begin
  fAliasField:=trim(AFieldName);
  i:=LastPos('_',fAliasField);
  if i>1 then mS:=AnsiUpperCase(copy(fAliasField,1,i-1)) else mS:=AnsiUpperCase(fAliasField);
  if Pos(mS,AnsiUpperCase(fSQLAliasField))=0 then fSQLAliasField:=mS;
end;

procedure TEFind.SetfField(AFieldName:String);
var i:integer;
    mS:String;
begin
  fField:=trim(AFieldName);
  i:=LastPos('_',fField);
  if i>1 then mS:=AnsiUpperCase(copy(fField,1,i-1)) else mS:=AnsiUpperCase(fField);
  if Pos(mS,AnsiUpperCase(fSQLField))=0 then fSQLField:=mS;
end;

procedure TEFind.SetfActive(AActive:Boolean);
begin
  fActive:=AActive;
  fFirst:=true;
  if Not fActive then begin
    Font.Color:=fNewColor;
    fNewValue:=true;
  end
  else MyRefresh;
end;

procedure TEFind.MyRefresh;
begin
    change;
end;

function TEFind.MyFind(AValue:string):boolean;
var mF:TFieldDef;
    mNumeric:boolean;
    c,mS,mField,mSQLField,mValue,mValue1,mValue2,mValue3,mValue4,mSQL:String;
    ch:char;
    mR:Double;
    mErr:integer;
begin
  if AValue='' then exit;
  if fFirst then begin
    fFirst:=false;
    if (Trim(fField)='') then begin
      Showmessage(Self.Name+'.FindFieldName is empty');
      FFirst:=true;
     exit;
    end;
    if (fCount>0) and (Trim(fSQLField)='') then begin
      Showmessage(Self.Name+'.FindSQLFieldName is empty');
      FFirst:=true;
      exit;
    end;
    if fByAlias then begin
      if (Trim(fAliasField)='') then begin
        Showmessage(Self.Name+'.FindAliasFieldName is empty');
        FFirst:=true;
        exit;
      end;
      if (Trim(fSQLAliasField)='') then begin
        Showmessage(Self.Name+'.FindSQLAliasFieldName is empty');
        FFirst:=true;
        exit;
      end;
    end;
  end;
  if fByAlias then begin
    mField:=fAliasField;
    mSQLField:=fSQLAliasField;
    mS:=NText;
    if mS<>'' then begin
      AValue:=mS;
    end else begin
      mField:=fField;
      mSQLField:=fSQLField;
    end;
  end else begin
    mField:=fField;
    mSQLField:=fSQLField;
  end;
  if not fQ.active then fQ.FieldDefs.Update;
  mF:=fQ.FieldDefs.Find(mField);
  if mF=nil then begin
    ShowMessage(Self.name+' Error: '+mField+' not exists');
    fFirst:=true;
    exit;
  end;
  mNumeric:= (mF.DataType in [ftSmallint, ftInteger, ftWord,ftFloat,ftAutoInc,
                              ftCurrency, ftBCD ]);
  try
    if (not mNumeric) and
       (not (mF.dataType in [ftDate, ftTime, ftDateTime])) and
       (length(AValue)>mF.Size) and
       (mF.Size>0) then AValue:=copy(AValue,1,mF.Size);
  except end;
  if (fCount=0) or (mF.dataType in [ftDate, ftTime, ftDateTime]) then begin
    if fQ.Active=false then fQ.Open;
    if fEq then Result:=fQ.Locate(mField,AValue,[])
     else Result:=fQ.Locate(mField,Variant(AValue),[loCaseInsensitive, loPartialKey]);
     fEq:=false;
  end else begin
    if fWhere<>'' then begin
      fQ.SQL_DeleteFromWhere(fWhere);
    end else fQ.Parse;

    if (fValue=AnsiUpperCase(AValue)) and fQ.Active then begin
      if fEq then Result:=fQ.Locate(mField,Variant(AValue),[])
       else Result:=fQ.Locate(mField,Variant(AValue),[loCaseInsensitive, loPartialKey]);
       fEq:=false;
    end else begin
      FValue:=AnsiLowerCase(copy(AValue,1,fCount));
      mValue:=fValue;
      c:=AnsiLowerCase(copy(AValue,fCount,1));
      mValue1:=mValue;
      if (not mNumeric) then begin
        mValue2:=mValue+fLastChar+fLastChar+fLastChar+fLastChar+fLastChar;
        mValue3:=AnsiUpperCase(mValue1);
        mValue4:=AnsiUpperCase(mValue1)+fLastChar+fLastChar+fLastChar+fLastChar+fLastChar;
        mSQL:='(('+mSQLField+'>='+#39+mValue1+#39+' and '+ mSQLField+'<='+#39+mValue2+#39+' ) or '+
              '('+mSQLField+'>='+#39+mValue3+#39+' and '+ mSQLField+'<='+#39+mValue4+#39+' ))';
        mValue:=uRozne.WithoutDiac(FValue);
        if FValue<>mValue then begin
          mValue1:=mValue;
          mValue2:=mValue+fLastChar+fLastChar+fLastChar+fLastChar+fLastChar;
          mValue3:=AnsiUpperCase(mValue1);
          mValue4:=AnsiUpperCase(mValue1)+fLastChar+fLastChar+fLastChar+fLastChar+fLastChar;
          mSQL:='( '+mSQL+' ) or ';
          mSQL:=mSQL+'(('+mSQLField+'>='+#39+mValue1+#39+' and '+ mSQLField+'<='+#39+mValue2+#39+' ) or ('+
                     '('+mSQLField+'>='+#39+mValue3+#39+' and '+ mSQLField+'<='+#39+mValue4+#39+' ))';
        end;
      end else begin //numeric
        if fNumToler<>0 then begin
          Val(FValue,mR,mErr);
          if mErr=0 then Str(mR-fNumToler,mValue1) else mValue1:=FValue;
          mValue1:=FValue;
          Val(mValue2,mR,mErr);
          if mErr=0 then Str(mR+fNumToler,mValue2) else mValue2:=FValue;
          mSQL:='('+mSQLField+'>='+mValue1+' and '+mSQLField+'<='+mValue2+')'
       end else begin
          mValue1:=FValue;
          mSQL:='('+mSQLField+'='+mValue1+')';
        end;
      end;
      fWhere:=mSQL;
      fQ.SQL_AddToWhere(mSQL);
      fQ.SQL.text:=fQ.SQL_New.text;
      fQ.Open;
      if fQ.Active then begin
        if fEq then Result:=fQ.Locate(mField,AValue,[])
         else Result:=fQ.Locate(mField,Variant(AValue),[loCaseInsensitive, loPartialKey]);
         fEq:=false;
      end;
    end;
  end;
end;

procedure TEFind.Change;
var mS:String;
    mL:integer;
begin
  if fExit or (Not fActive) then begin
    fExit:=false;
    Inherited Change; exit;
  end;
  if fQ=nil then exit;
  if MyFind(text) then begin
    Font.Color:=fExistColor;
    mS:=fQ.FieldByName(fField).asString;
    fExit:=true;
    mL:=length(text);
    text:=mS;
    SelStart:=mL;
    SelLength:=length(text)-mL;
  end else begin
    Font.Color:=fNewColor;
    fNewValue:=true;
  end;
  if Assigned(fAfterChange) then fAfterChange(self);
end;


procedure TEFind.KeyDown(var Key: Word; Shift: TShiftState);
var a:integer;
begin
  if fActive and (fQ<>nil) then begin
    if (key=13) and fNewValue then begin change;key:=0; end;
    if key=Vk_delete then begin
      fExit:=true;
      fNewValue:=true;
      Font.Color:=fNewColor;
    end;
    if (readOnly=false) and (key=VK_BACK) then begin
      a:=SelLength;SelStart:=SelStart-1; Sellength:=a+1; key:=0;
      if SelLength=Length(text) then begin
        fExit:=true;
        text:='';
      end;
    end;
    if (ReadOnly=false) and (key=Vk_next) then begin //PgDn

      key:=0;
       if fQ.active then begin
         fQ.Next;
         fExit:=true;
         text:=fQ.FieldByName(fField).asString;
         fNewValue:=false;
         fExit:=false;
         if Assigned(fAfterChange) then fAfterChange(self);
      end;
    end;
    if (readonly=false) and (key=Vk_Prior) then begin  //PgUp
      key:=0;
      if fQ.active then begin
        fQ.Prior;
        fExit:=true;
        text:=fQ.FieldByName(fField).asString;
        fNewValue:=false;
        fExit:=false;
        if Assigned(fAfterChange) then fAfterChange(self);
      end;
    end;
  end;
  inherited keyDown(key,shift);
end;

(*
procedure Register;
begin
  RegisterComponents('Samples', [TEFind]);
end;
*)

end.
