unit uELister;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,stdctrls,uEStr,DB,DbTables;

type
  TElisterSave=procedure (sender:Tobject; pQ:TQuery) of object;
  TELister = class(TEStr)
  private
    fOnSave:tElisterSave;
    fAfterChange:TNotifyEvent;
    fOldText:string;
    fActive:boolean;
    fQ:TQuery;
    fExit:boolean;
    fNewValue:Boolean;
    fStartLength:byte;
    fSelect:string;
    fWhereEx:String;
    fDisplayField:string;
    fAliasField:String;
    fOrder:String;
    fNewColor:Tcolor;
    fFontColor:TColor;
    fNoByAlias:boolean;
    fExact,fRefresh:boolean;
    procedure SetStartLength(pS:byte);
    procedure SetNewValue(pB:boolean);
    { Private declarations }
  protected
    procedure Change; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure  Notification(AComponent: TComponent; Operation: TOperation); override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
    property OnAfterChange: TNotifyEvent read fAfterChange write fAfterChange;
    property NewValueFontColor: TColor read fNewColor write fNewColor;
    property FontColor: TColor read fFontColor write fFontColor;
    property Active:boolean read fActive write fActive;
    property StartLength:byte read fStartLength write SetStartLength;
    property NewValue: boolean read fNewValue write SetNewValue;
    property Query:TQuery read fQ write fQ;
    property SQL_Select: string read fSelect write fSelect;
    property AliasFieldName: string read fAliasField write fAliasField;
    property DisplayFieldName: string read fDisplayField write fDisplayField;
    property SQL_WhereExpression:string read fWhereEx write fWhereEx;
    property SQL_Order: string read fOrder write fOrder;
    property NoFindByAlias:boolean read fNoByAlias Write fNoByAlias;
    property OnSave:TEListerSave read fOnSave write fOnSave;
    procedure Refresh;
    procedure Save;
    procedure Open;
   { Published declarations }
  end;

(*procedure Register;*)

implementation

constructor TELister.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fFontColor:=clBlack;
  fNewColor:=clBlue;
  fStartLength:=0;
End;

procedure TELister.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent=fQ) then fQ:=nil;
End;

procedure TELister.SetStartlength(pS:byte);
begin
  if pS>10 then pS:=10;
  if fStartLength<>pS then begin
    fStartLength:=pS;
    fOldText:='';
  end;
end;
procedure TELister.SetNewValue(pB:boolean);
begin
 fNewValue:=pB;
 if pB then Font.Color:=fNewColor else Font.Color:=fFontColor;
end;

procedure TELister.Refresh;
begin
  fRefresh:=true;
  try
    change;
  finally fRefresh:=false; end;
end;

procedure TElister.Open;
begin
  if fQ=nil then exit;
  if fQ.active=false then begin
    fQ.SQL.Clear;
    fQ.SQL.add(fSelect);
    if Trim(fWhereEx)<>'' then fQ.SQL.add('where ('+fWhereEx+')');
    fQ.SQL.add(fOrder);
    fQ.Open;
  end;
end;

procedure TELister.Change;
var mS,mT:String;
    mL,mLen:Integer;
    mB:boolean;
    mAliasField:string;
begin
  if not fActive then exit;
  Font.Color:=fFontColor;
  Open;
  if text='' then fExact:=false;   //presna hodnota
  if not fRefresh then Inherited Change;
  if not fActive then exit;
  if fQ=nil then exit;
  if not fNoByAlias then begin
   if (Trim(fDisplayField)='') or (Trim(fAliasField)='') then begin
     Showmessage(Self.Name+'.DisplayFieldName or AliasFieldName is empty');
     exit;
   end;
  end;
  if fNoByAlias then mAliasField:=fDisplayField else mAliasField:=fAliasField;
  if fExit then exit;
  mS:=TrimLeft(text);   mL:=Length(mS);
  if mS='' then exit;
  if mAliasField<>fDisplayField then begin
    mS:=NText;
    if mS='' then begin
      mAliasField:=fDisplayField;
      mS:=TrimLeft(text);
    end;
  end;
  mT:='';
  (*
  mB:=false;
  if mS<>'' then begin
    if (fOldtext='') then begin
      mB:=true; fOldtext:=AnsiUppercase(copy(mS,1,fStartLength));
    end else begin
      mB:=fOldtext<>AnsiUppercase(copy(mS,1,fStartlength));
      fOldtext:=AnsiUppercase(copy(mS,1,fStartlength));
    end;
  end;
    //if mB or ((fQ.Active=false) and (mL>=fStartLength)) then begin
    fQ.SQL.Clear;
    fQ.SQL.add(fSelect);
    if Trim(fWhereEx)<>'' then
      if fStartLength<1 then fQ.SQL.add('where ('+fWhereEx+')')
      else fQ.SQL.add('where ('+fWhereEx+') and '+mAliasField+' Like "'+Copy(mS,1,fStartLength)+'%"')
    else
      if fStartLength>0 then fQ.SQL.add('where '+mAliasField+' Like "'+Copy(mS,1,fStartLength)+'%" ');
    fQ.SQL.add(fOrder);
    fQ.Open;
  end;
    if mL<=fStartLength then
      mT:=fQ.FieldByName(fDisplayField).asString
    else begin
      mLen:=fQ.FieldByName(mAliasField).dataSize-1;
      if mLen<1 then mLen:=1;
      mS:=copy(mS,1,mLen);
  *)
  if Length(text)=1 then fQ.Refresh;
  if fQ.Locate(mAliasField,mS,[loCaseInsensitive,loPartialKey]) then mT:=fQ.FieldByName(fDisplayField).asString;
    //end;

  (*
  end else begin
    if fQ.Active and (mS<>'') then begin
      TRY
        mLen:=fQ.FieldByName(mAliasField).dataSize-1;
        if mLen<1 then mLen:=1;
        mS:=copy(mS,1,mLen);
        if fQ.Locate(mAliasField,Variant(mS),[loCaseInsensitive,loPartialKey]) then mT:=fQ.FieldByName(fDisplayField).asString;
      EXCEPT END;
    end;
  end; *)
  if mT<>'' then begin
    if fExact and (AnsiUpperCase(trim(text))<>AnsiUpperCase(Trim(mT))) then
    fNewValue:=true else fNewValue:=false;
    fExit:=true;
    try
      if not fExact then text:=mT;
    finally fExit:=false; end;

    if (mS[length(mS)]=' ') and (mL>0) and (Length(text)<mL) and (fNewValue=false) then begin
      fExit:=true;
      text:=text+' ';
      fExit:=false;
    end;
    SelStart:=mL;
    SelLength:=length(text)-mL;
  end else fNewValue:=true;
  if fNewValue then Font.Color:=fNewColor;
  if Assigned(fAfterChange) then fAfterChange(self);
  fExact:=false;
end;


procedure TELister.KeyDown(var Key: Word; Shift: TShiftState);
var a:integer;
begin
  if (fQ<>nil) and (fQ.active) and (length(text)>1) and(key=vk_back) or (key=vk_delete) then begin
    fExact:=true;   //presna hodnota
  end;
  if (readOnly=false) and (key=VK_F9) then begin
    fNoByAlias:=Not fNoByAlias;
    if fAliasField<>fDisplayField then begin
      if fNoByAlias then ShowMessage('F9 Off/on - Not find by alias') else ShowMessage('F9 On/off- Find by alias');
    end;
    key:=0;
  end;
  if fActive and (fQ<>nil) then begin
    //if key=Vk_delete then begin text:=''; key:=0; end;
    if (readOnly=false) and (key=VK_BACK) then begin a:=SelLength;SelStart:=SelStart-1; Sellength:=a+1; key:=0; end;
    if (ReadOnly=false) and (key=Vk_next) then begin //PgDn

      try
        key:=0;
        if fQ.active then fQ.Next else begin
          if fStartlength=0 then begin
            fQ.SQL.Clear;
            fQ.SQL.add(fSelect);
            if Trim(fWhereEx)<>'' then fQ.SQL.add('where ('+fWhereEx+')');
            fQ.SQL.add(fOrder);
            try fQ.Open; except end;
          end;
        end;
        if fQ.active then begin
          fExit:=true;
          try
            text:=fQ.FieldByName(fDisplayField).asString;
            fNewValue:=false;
            if Assigned(fAfterChange) then fAfterChange(self);
          finally fExit:=false; end;
        end;
      except end;
    end;
    if (readonly=false) and (key=Vk_Prior) then begin  //PgUp
      try
        key:=0;
        if fQ.active then fQ.Prior else begin
          if fStartlength=0 then begin
            fQ.SQL.Clear;
            fQ.SQL.add(fSelect);
            if Trim(fWhereEx)<>'' then fQ.SQL.add('where ('+fWhereEx+')');
            fQ.SQL.add(fOrder);
            try fQ.Open; except end;
          end;
        end;
        if fQ.active then begin
          fExit:=true;
          try
            text:=fQ.FieldByName(fDisplayField).asString;
            fNewValue:=false;
            if Assigned(fAfterChange) then fAfterChange(self);
          finally fExit:=false; end;
        end;
      except end;
    end;
  end;
  inherited keyDown(key,shift);
end;

procedure TELister.Save;
begin
  if fActive and fNewValue then begin
    if Assigned(fOnSave) then fOnSave(Self,fQ);
//    fNewValue:=false;
//    Font.Color:=fFontColor;
  end;
end;

(*
procedure Register;
begin
  RegisterComponents('Edge', [TELister]);
end;
*)

end.
