unit uENum;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,uEStr;

type
  TENum = class(TEStr)
  private
    oNoChange:boolean;
    oFix     :boolean;
    oInt     :longint;
    oFloat   :double;
    oOldText :string;
    oFirstOldText :string;
    oMin,oMax:double;
    oFrac    :byte;
    oCreate  :boolean;
    procedure SetInt(pI:Longint);
    procedure SetFloat(pD:double);
    procedure SetFix(pB:boolean);
    procedure Kontrola;
    { Private declarations }
  protected
    procedure Change; override;
    procedure KeyPress(var Key:char); override;
    Procedure KeyDown(var Key: Word; Shift: TShiftState);override;
    procedure DoExit; override;
    procedure DoEnter; override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    { Public declarations }
  published
    property Min:double read oMin write oMin;
    property Max:double read oMax write oMax;
    property Frac:byte read oFrac write oFrac;
    property FixFrac: boolean read oFix write SetFix;
    property AsInteger:longint read oInt write SetInt;
    property AsFloat  :double  read oFloat write SetFloat;
    function IsOk(pDlg:boolean):boolean;
    { Published declarations }
  end;

(*procedure Register;*)

implementation

constructor TENum.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  oCreate:=true;
  Text:=''; oOldText:='0';
  oNoChange:=false;
  oMin:=0;
  oMax:=0;
  oFrac:=2;
  oCreate:=false;
end;

Procedure TENum.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Key=vk_delete) and (ssCtrl in Shift) then Key:=0;
  if oFix and (Key=vk_delete) and (SelStart=pos('.',text)-1) then key:=0;
  inherited keyDown(key,Shift);
end;

procedure TENum.DoEnter;
begin
  oFirstOldText:=Text;
  oOldText:=Text;
  inherited DoEnter;
end;

function TENum.IsOk(pDlg:boolean):boolean;
var mD:double;
    mErr:integer;
begin
  Result:=false;
  mD:=0;
  if Trim(Text)<>'' then begin
    System.Val(Text,mD,mErr);
    if mErr>0 then begin
      if pDlg then begin
        MessageDlg(Self.Name+', nekorekn hodnota: '+Text+'.',mtWarning,[mbOk],0);
        Self.SetFocus;
      end;
      Exit;
    end;
  end;
  if not ((oMin=oMax) and (oMin=0)) then begin
    if (mD>oMax) or (mD<oMin) then begin
      if pDlg then begin
        MessageDlg(Self.Name+', hodnota mus by v rozpt <'+FloatToStr(oMin)+
                 ';'+FloatToStr(oMax)+'>',mtWarning,[mbOk],0);
        Self.SetFocus;
      end;
      Exit;
    end;
  end;
  Result:=true;
End;

procedure TENum.DoExit;
begin
  IsOk(true);
  inherited DoExit;
End;

procedure TENum.KeyPress(var Key:char);
var mM:set of char;
    i:integer;
begin
  if key=#13 then oFirstOldText:=text;
  if key=#27 then Text:=oFirstOldText;
  mM:=['0'..'9','.','-',#0..#27];
  if key='*' then text:='';
  if key=',' then key:='.';
  if Pos('.',Text)>0 then mM:=mM-['.'];
  if Pos('-',text)=1 then mM:=mM-['-'];
  if (Key=#8) {back} and oFix then begin
    i:=Pos('.',text);
    if (SelStart=i) and (i>1) then begin
      SelStart:=i-1; Key:=#0;
    end;
  end;
  (*
  if (Pos('0',text)=1) and (SelStart<2) and (Key in ['0'..'9']) then begin
    oNoChange:=false; i:=selStart;
    if Pos('.',text)=i+1 then begin
      Text:=Key+copy(text,2,Length(text));
      key:=#0;
    end else Text:=copy(text,2,Length(text));
    SelStart:=i;
  end;
  *)
  if (Key='.') and (Pos('.',text)>0) then SelStart:=Pos('.',text);
  if not (Key in mM) then Key:=#0;
  inherited keyPress(key);
End;


procedure TENum.Kontrola;
var mD       : double;
    i,j,mErr : integer;
    mS      : String;
begin
  oInt:=0; oFloat:=0.0;
  if Text<>'' then begin
    mD:=0.0;oFloat:=0.0;
    if Pos('.',text)=1 then begin
      oNoChange:=true;i:=SelStart;
      Text:='0'+text;
      oNoChange:=false;
      SelStart:=i+1;
    end;
    if oFix and (oFrac>=0) and (Text='') then begin
      oNoChange:=true;i:=SelStart;
      mS:='0';
      if oFrac>0 then begin
        mS:=mS+'.';
        for i:=1 to oFrac do mS:=mS+'0';
      end;
      Text:=mS;
      oNoChange:=false;
      If Length(oOldtext)>=i then SelStart:=i else SelStart:=Length(oOldText)+1;
    end;
    if (oFix) and (oFrac>0) and (Pos('.',text)=0) {and (Pos('.',oOldText)>0)} then begin
      oNoChange:=true;i:=SelStart;
      Text:=text+'.0';
      oNoChange:=false;
      If Length(Text)>=i then SelStart:=i else SelStart:=Length(Text)+1;
    end;
    mS:=Text; mErr:=0;mS:=trim(mS);
    if mS<>'' then begin
      if mS[1]in ['0'..'9','.','-'] then begin
        System.VAL(mS,mD,mErr);
      end else mErr:=-1;
    end;
    oFloat:=mD;
    if mErr>0 then begin
      if mErr<=length(mS) then begin
        if (Pos('.',mS)<>mErr) or (mS[mErr]<>'.') then begin
          oNoChange:=true;i:=SelStart;
          Text:=oOldText;
          oNoChange:=false;
          If Length(oOldtext)>=i then SelStart:=i else SelStart:=Length(oOldText)+1;
        end;
      end;
    end;
    j:=System.Pos('.',Text);mS:='';
    if (j>0) then begin
      if (oFrac<1) then begin
        oNoChange:=true;i:=SelStart;
        Text:=oOldText;
        oNoChange:=false;
        If Length(oOldtext)>=i then SelStart:=i else SelStart:=Length(oOldText)+1;
      end else begin
        if (j<length(text)) then mS:=copy(Text,j+1,255);
        if mS<>'' then begin
          if length(mS)>oFrac then begin
            mS:=text;
            system.delete(mS,j+oFrac+1,255);
            i:=SelStart;
            Text:=mS;
            If Length(mS)>=i then SelStart:=i else SelStart:=Length(mS)+1;
          end;
        end;
      end;
    end;
  end;
  j:=Pos('.',Text); oInt:=0;
  if j>1 then begin
    System.Val(copy(Text,1,j-1),oInt,mErr);
  end else begin
    if j=0 then System.Val(Text,oInt,mErr);
  end;
  if (oFix) and (oFrac>0) then begin
    mS:=Trim(Text);if mS='' then mS:='0';
    i:=Pos('.',mS);
    if i=0 then mS:=mS+'.'+copy('0000000000000',1,oFrac);
    if (i>0) then if length(mS)-i<oFrac then mS:=mS+copy('00000000000000',1,oFrac-(length(mS)-i) );
    i:=selStart;
    oNoChange:=true;
    Text:=mS;
    oNoChange:=false;
    SelStart:=i;
  end;
End;

(*
procedure TENum.Kontrola; {uroby designovu upravu}
var mT  :string;
    mD  :double;
    i,mL:integer;
    mFirst1,mFirst2:boolean;
begin
   mFirst1:=true;mFirst2:=true;
   if oCreate then exit;
   mT:=Text;
   while true do begin
      mT:=Trim(mT);
      oInt:=0; oFloat:=0;
      {uvodne nuly}
      while pos('0',mT)=1 do delete(mT,1,1);
      if mT='' then mT:='0';
      i:=pos('.',mT); mL:=Length(mT);
      if i=1 then mT:='0'+mT;
      {ked je viac des. miest}
      i:=pos('.',mT); mL:=Length(mT);
      if oFrac>0 then begin
        if i>0 then begin
          if mL-i>oFrac then delete(mT,mL-i+oFrac,255);
        end;
      end else begin
        if i>0 then delete(mT,i,length(mT));
      end;
      {ked je povinna fixna dlzka des.}
      i:=pos('.',mT); mL:=Length(mT);
      if oFix and (oFrac>0) then begin
        if i=0 then mT:=mT+'.0';
        i:=pos('.',mT); mL:=Length(mT);
        while  Length(mT)-i<oFrac do mT:=mT+'0';
      end;
      {inicializace hodnot - ked to nie je ziadne cislo}
      mD:=0.0; i:=0 ;Val(mT,mD,i);
      oFloat:=mD;
      if (i<>0) and (mT<>oOldText) and mFirst2 then begin
        mFirst2:=false; mT:=oOldText; Continue;
      end;
      if (i<>0) and mFirst1 then begin
        mT:='0'; mFirst1:=false; Continue;
      end;
      Break;
    end;
    i:=pos('.',mT); if i=0 then i:=Length(mT)+1;
    System.Val(copy(mT,1,i-1),oInt,i);
    {zapis do Text vlastnosti}
    oNoChange:=true; i:=SelStart;  Text:=mT; oNoChange:=false;
End;
*)

procedure TENum.Change;
begin
  if (not oNoChange) then Kontrola;
  Inherited Change;
  if not oNoChange then oOldText:=text;
End;

procedure TENum.SetFix(pB:boolean);
begin
  oFix:=pB;
  Kontrola;
end;

procedure TENum.SetInt(pI:longint);
begin
  if oInt<>pI then Text:=IntToStr(pI);
end;

procedure TENum.SetFloat(pD:double);
var mS:string;
begin
  if oFloat<>pD then begin
    if oFix then Str(pD:0:oFrac,mS) else Str(pD:0:8,mS);
    Text:=mS;
  end;
end;

(*
procedure Register;
begin
  RegisterComponents('Edge', [TENum]);
end;
*)
END.
