unit uReg;
(*
  TReg - komponent pre registaciu
  Autor: Tungli Jan 1999; Email:jan.tungli@seznam.cz
  Home page: http://free.netlap.hu/4321/
  Umoznuje:
    Trail version - iba 90 dnova verzia  (podla DirectoryTime)
    Unikatnu registraciu na kazdu stanicu pomocou Serioveho cisla lokalneho hardisku
    Registraciu podla mena uzivatela (majitela) default.
    ProjectName - je skupina programovych modulov pod ktorym budu v registroch ulozene
                  registracne udaje prog. modulov
    Pocas registracie je spusteny program SupportReg.exe - potom po stalceni OK sa vykona registracia.
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,uRozneRep;

type
  Tlang=(x_Slovak,x_Hungarian,x_English);
  TReg = class(TComponent)
  private
    oRUser:boolean;
    oLang:Tlang;
    oUser:string;
    oProj:string;
    oSerial:boolean;
    oV:boolean;
    oTrial:boolean;
    procedure SetView(pV:boolean);
    { Private declarations }
  protected
    { Protected declarations }
  public
    constructor Create(AOwner:TComponent);
    { Public declarations }
  published
    property Language:TLang read oLang write oLang; //akom jazyku
    property ProjectName:string read oProj write oProj; // cely project - moze mat viac programov
    property WithSerialNumber:boolean read oSerial write oSerial; // viazat na serial number
    property Trial:boolean read oTrial write oTrial;  // ci 90 dnova verzia
    property m_View:boolean read oV write SetView;
    property DefaultUser:string read oUser write oUser;
    property ReadOnlyUser:boolean read oRUser write oRUser;
    function OK:boolean; // ci je registracia OK
    procedure Execute;  // zaregistruj sa

    procedure Save(pKey:integer);
    function Load:string;
    function Krypt:integer;
    { Published declarations }
  end;

{procedure Register;}

implementation
uses uRegist1;

constructor TReg.Create(AOwner:TComponent);
begin
  Inherited Create(Aowner);
End;

procedure Treg.execute;
begin
  m_view:=true;
end;

procedure Treg.Save(pKey:integer);
var mS:string;
begin
  mS:=ExtractFileName(Application.ExeName);
  if pos('.',mS)>0 then delete(mS,Pos('.',mS),200);
  if trim(oProj)='' then begin ShowMessage('TReg: Error, ProjectName=?'); exit; end;
  SetStrValRegKey(HKEY_CURRENT_USER,
                'software\'+oProj+'\'+mS,'RegKey',IntToStr(pKey));
  SetStrValRegKey(HKEY_CURRENT_USER,
                'software\'+oProj+'\'+mS,'User',oUser);
end;

function TReg.Load:string;  // vrati regKey alebo prazdny sring
var mS, mRegKey:string;
begin
  oUser:=DefaultUser;
  mRegKey:=''; result:='';
  if oTrial then begin
    mS:=ExtractFilePath(Application.ExeName);
    if mS[length(mS)]<>'\' then mS:=mS+'\';
    mS:=GetDirectoryTime(mS+'*.*');
    if (Date-90>StrToDateTime(mS)) or (Date<StrToDateTime(mS)) then begin
      //MessageDlg('Tial version (90 days) - please, remove program.',mtWarning,[mbOk],0)
      Exit;
    end;
  end;
  mS:=ExtractFileName(Application.ExeName);
  if pos('.',mS)>0 then delete(mS,Pos('.',mS),200);
  GetStrValRegKey(HKEY_CURRENT_USER,
                'software\'+oProj+'\'+mS,'RegKey',mRegKey);  // aktivizuje oUser
  GetStrValRegKey(HKEY_CURRENT_USER,
                'software\'+oProj+'\'+mS,'User',oUser);
  if (mRegKey<>'') then begin
    if mRegKey=intToStr(Krypt) then result:=mRegKey;
  end;
end;

function Treg.OK:boolean;
begin
  Result:=(Load<>'');
end;

function TReg.Krypt:integer;
var mS,mT:String;
    i:integer;
begin
  result:=0;
  if WithSerialNumber then begin
    mS:=GetCurrentDir;
    mS:=copy(mS,1,2)+'\';
    if mS[2]=':' then mS:=SerialNumberStr(mS);
  end else mS:=oUser;
  mS:=copy(mS+'1234567890',1,10);
  mT:='918273645564738291';
  for i:=1 to 10 do result:=result+(byte(mT[i])*byte(mS[i])) mod 7 + byte(mT[i]) + byte(mS[i]);
  result:=result*10+(result mod 107)+1000*(result mod 3)+byte(mS[2])*10000-byte(mS[1]);
end;

procedure Treg.SetView(pV:boolean);
begin
  if pV then begin
    oV:=true;
    Execute_Reg(self);
  end;
  oV:=false;
end;

(*
procedure Register;
begin
  RegisterComponents('Samples', [TReg]);
end;  *)

end.
