unit uSuperFilters;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uEStr, ExtCtrls, uECombo, uSuperFields,uRozne, uBlokEdit, uEDBGrid,DB,DBTables;

type
  TF_SuperFilters = class(TForm)
    Label3: TLabel;
    ECombo3: TECombo;
    Button3: TButton;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EStr4: TEStr;
    Button2: TButton;
    EStr1: TEStr;
    Button4: TButton;
    ECombo4: TECombo;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Button1: TButton;
    Button5: TButton;
    procedure ECombo3Change(Sender: TObject);
    procedure ECombo3Exit(Sender: TObject);
    procedure ECombo3KeyPress(Sender: TObject; var Key: Char);
    procedure EStr1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    fFilter:TStringList;
    fGrid:TEDBGrid;
    fQuery:TQuery;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_SuperFilters: TF_SuperFilters;

  procedure Execute_SuperFilters(pGrid:TEDBGrid;pFilter:TStringList);

implementation

{$R *.DFM}
procedure Execute_SuperFilters(pGrid:TEDBGrid;pFilter:TStringList);
begin
  if F_SuperFilters=nil then Application.CreateForm(TF_SuperFilters,F_SuperFilters);
  with F_SuperFilters do begin
    try
      fFilter:=pFilter;
      fGrid:=pGrid;
      fQuery:=TQuery(pGrid.DataSource.dataSet);
      ECombo3.Items.Clear;
      BlokNames(fFilter,TstringList(ECombo3.Items));
      ECombo3.Items.Add('');
      ShowModal;
    finally
      Free;
      F_SuperFilters:=nil;
    end;
  end;
end;

procedure TF_SuperFilters.ECombo3Change(Sender: TObject);
var mS:String;
begin
  mS:=trim(AnsiLowerCase(ECombo3.text));
  if mS='' then exit;
  if mS[length(mS)]<>';' then begin
  end else begin
    Memo1.Lines.Clear;
    if BlokIndex(mS,fFilter)>-1 then BlokBody(mS,fFilter,TstringList(memo1.Lines));
    EStr1.text:='';
    EStr4.text:='';
  end;
  Panel4.Enabled:=Ecombo3.text<>'';
end;


procedure TF_SuperFilters.ECombo3Exit(Sender: TObject);
var mS:String;
begin
  mS:=Trim(ECombo3.text);
  if mS='' then exit;
  if mS[Length(mS)]<>';' then begin
    ECombo3.text:=Trim(mS)+';';
    ECombo3Change(sender);
  end;
end;


procedure TF_SuperFilters.ECombo3KeyPress(Sender: TObject; var Key: Char);
var mS:String;
begin
  if key=#13 then begin
    mS:=trim(ECombo3.text);
    if mS='' then exit;
    if mS[Length(mS)]<>';' then begin
      ECombo3.text:=Trim(mS)+';';
      ECombo3Change(sender);
    end;
  end;
end;


procedure TF_SuperFilters.EStr1Change(Sender: TObject);
var mS:String;
begin
  mS:=fGrid.GetFieldName(Estr1.text,F_sql,f_dataset);
  CheckBox1.checked:= not (ord(fQuery.FindField(mS).dataType) in  cNumDBFields+cBooleanDBFields)
end;

procedure TF_SuperFilters.Button3Click(Sender: TObject);
var i:integer;
begin
  if Trim(ECombo3.text)='' then exit;
  if messageDlg('Do you want delete filter '+ECombo3.text+'?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
  Memo1.Clear;
  BlokEdit(Ecombo3.text,TStringList(memo1.lines),fFilter);
  i:=Ecombo3.Items.IndexOf(Trim(AnsiLowerCase(ECombo3.text)));
  if i>=0 then ECombo3.Items.delete(i);
end;

procedure TF_SuperFilters.Button4Click(Sender: TObject);
var mS:String;
begin
  mS:=Execute_SuperFields(fGrid);
  EStr1.text:=mS;
end;

procedure TF_SuperFilters.Button2Click(Sender: TObject);
var i,j:integer;
    mRel,mV:String;
begin
  if trim(eStr1.text)='' then exit;
  if trim(eStr4.text)='' then exit;
  if trim(eCombo4.text)='' then exit;
  mRel:=lowercase(trim(ECombo4.text));
  i:=pos(':(',mRel);
  if i>0 then begin
    mRel:=trim(copy(mRel,i+2,255));
    mRel:=trim(copy(mRel,1,Length(mRel)-1));
    if Pos('like',mRel)>0 then begin
       if not CheckBox1.checked then begin messageDlg('Field '+EStr1.text+' is not text type',mtError,[mbOk],0); exit; end;
       i:=Pos(#39+'%',mRel);
       j:=Pos('%'+#39,mRel);
       mRel:='like';
       if (i>0) then begin
         if j>i then mV:=#39+'%'+EStr4.text+'%'+#39
         else mV:=#39+'%'+EStr4.text+#39
       end else begin
         if j>0 then mV:=#39+Estr4.text+'%'+#39;
       end;
    end;
  end;
  if Checkbox1.checked and (trim(lowerCase(mRel))<>'like') then mV:=#39+Estr4.text+#39;
  if memo1.lines.Count=0 then
    memo1.lines.add(EStr1.text+mRel+mV)
  else
    memo1.lines.add(' and '+EStr1.text+' '+mRel+' '+mV);
end;


procedure TF_SuperFilters.Button1Click(Sender: TObject);
begin
  Memo1Exit(sender);
  BlokEdit(Ecombo3.text,TStringList(memo1.lines),fFilter);
  if memo1.Lines.Count>0 then begin
    if Ecombo3.Items.IndexOf(Trim(AnsiLowerCase(ECombo3.text)))<0 then
      ECombo3.Items.add(Trim(AnsiLowerCase(ECombo3.text)));
  end;
end;

procedure TF_SuperFilters.Memo1Exit(Sender: TObject);
var i:integer;
begin
  for i:=Memo1.Lines.Count-1 downto 0 do begin
    if Trim(Memo1.Lines.Strings[i])='' then memo1.Lines.delete(i);
  end;
end;

procedure TF_SuperFilters.Button5Click(Sender: TObject);
begin
  Close;
end;

end.
