unit uSuperQueryDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Tabnotbk, StdCtrls, uECombo, Buttons, 
  uEDBGrid, Grids, DBGrids, Db, DBTables, uEStr, uRozne, uBlokEdit,Clipbrd,
  Menus,uEQuery;
type
  TF_SuperQueryDialog = class(TForm)
    TabbedNotebook1: TTabbedNotebook;
    Panel1: TPanel;
    DataSource1: TDataSource;
    EDBGrid1: TEDBGrid;
    Panel2: TPanel;
    EFilter1: TEFilter;
    ECombo1: TECombo;
    Label1: TLabel;
    Label2: TLabel;
    ECombo2: TECombo;
    ListBox1: TListBox;
    Panel3: TPanel;
    CheckBox2: TCheckBox;
    Button6: TButton;
    ECombo6: TECombo;
    Label9: TLabel;
    Label10: TLabel;
    StringGrid1: TStringGrid;
    Label3: TLabel;
    Panel4: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EStr4: TEStr;
    Button2: TButton;
    ECombo3: TECombo;
    Button3: TButton;
    EStr1: TEStr;
    Button4: TButton;
    ECombo4: TECombo;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Button1: TButton;
    Panel5: TPanel;
    Label7: TLabel;
    ListBox2: TListBox;
    Label8: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ListBox3: TListBox;
    Button5: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton6: TRadioButton;
    Button7: TButton;
    SaveDialog1: TSaveDialog;
    ListBox4: TListBox;
    Memo2: TMemo;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    PopupMenu1: TPopupMenu;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ECombo3Change(Sender: TObject);
    procedure ECombo3KeyPress(Sender: TObject; var Key: Char);
    procedure ECombo3Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure EStr1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ECombo6Exit(Sender: TObject);
    procedure ECombo6KeyPress(Sender: TObject; var Key: Char);
    procedure ECombo6Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ECombo2Change(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ECombo1Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    fQuery:TEQuery;
    fFilter,fExport:TStringList;
    fExportType:byte;
    fOldFilter,fStartSQL:String;
    procedure MyFields;
    procedure MyExports;
    procedure ExecuteExport;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_SuperQueryDialog: TF_SuperQueryDialog;

  procedure Execute_SuperQueryDialog(pQuery:TEQuery; pFilter,pExport:TStringList);

implementation
uses uSuperFields;
{$R *.DFM}

procedure Execute_SuperQueryDialog(pQuery:TEQuery; pFilter,pExport:TStringList);
var mA:Boolean;
begin
  mA:=pQuery.Active;
  if not mA then begin
    try pQuery.Active:=true; except end;
  end;
  if not pQuery.Active then begin
    ShowMessage(pQuery.Name+' open error');
    exit;
  end;
  if F_SuperQueryDialog=nil then Application.CreateForm(TF_SuperQueryDialog,F_SuperQueryDialog);
  with F_SuperQueryDialog do begin
    try
      fQuery:=pQuery;
      SaveDialog1.InitialDir:=GetCurrentDir;
      fStartSQL:=fQuery.SQL.text;
      DataSource1.DataSet:=fQuery;
      fFilter:=TStringList.Create;
      fExport:=TStringList.Create;
      fFilter.Assign(pFilter);
      fExport.Assign(pExport);
      ShowModal;
      pFilter.Assign(fFilter);
      pExport.Assign(fExport);
    finally
      if not mA then pQuery.Active:=false;
      fFilter.Free;
      fExport.Free;
      Free;
      F_SuperQueryDialog:=nil;
    end;
  end;
end;


procedure TF_SuperQueryDialog.TabbedNotebook1Change(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
begin
 case newTab of
 0: begin
      ECombo1.Items.Assign(ECombo3.Items);
      ECombo2.Items.Assign(ECombo6.Items);
    end;
 1: MyFields;
 3: MyExports;
 end;{case}
end;

procedure TF_SuperQueryDialog.MyFields;
var i:integer;
begin
  With fQuery do begin
    with StringGrid1 do begin
      RowCount:=ListBox1.Items.Count+1;
      Cells[0,0]:='No';
      Cells[1,0]:='Title field name';
      Cells[2,0]:='Dataset field name';
      Cells[3,0]:='Type';
      cells[4,0]:='Size';
      cells[5,0]:='SQL alias.field';
      cells[6,0]:='SQL table.field';
      for i:=0 to ListBox1.Items.Count-1 do begin
        cells[0,i+1]:=EDBGrid1.GetFieldName(ListBox1.Items[i],ff_dataset,ff_no);
        cells[1,i+1]:=EDBGrid1.GetFieldName(ListBox1.Items[i],ff_dataset,ff_title);
        cells[2,i+1]:=ListBox1.Items[i];
        cells[3,i+1]:=cDBFieldTypes[ord(fQuery.FindField(ListBox1.Items[i]).DataType)];
        cells[4,i+1]:=IntToStr(fQuery.FindField(ListBox1.Items[i]).DataSize);
        //cells[5,i+1]:=EDBGrid1.GetFieldName(ListBox1.Items[i],f_dataset,f_sql);
        //cells[6,i+1]:=EDBGrid1.GetFieldName(ListBox1.Items[i],f_dataset,f_sqltable);
      end;
   end;
   Label10.caption:='Record size: '+intToStr(fQuery.RecordSize);
  end;
end;

procedure TF_SuperQueryDialog.CheckBox2Click(Sender: TObject);
begin
 ListBox1.Sorted:=CheckBox2.Checked;
 MyFields;
end;

procedure TF_SuperQueryDialog.FormActivate(Sender: TObject);
begin
  fQuery.Open;
  TabbedNotebook1.pageIndex:=0;
  ECombo3.Items.Clear;
  BlokNames(fFilter,TstringList(ECombo3.Items));
  ECombo3.Items.add('');
  fQuery.GetFieldNames(ListBox1.Items);
  BlokNames(fExport,TstringList(ECombo6.Items));
  ECombo6.Items.add('');
  ECombo1.Items.Assign(ECombo3.Items);
  ECombo2.Items.Assign(ECombo6.Items);
end;

procedure TF_SuperQueryDialog.ECombo3Change(Sender: TObject);
var mS:String;
begin
  mS:=trim(AnsiLowerCase(ECombo3.text));
  if mS='' then exit;
  if mS[length(mS)]<>';' then begin
  end else begin
    Memo1.Lines.Clear;
    if BlokIndex(mS,fFilter)>-1 then BlokBody(mS,fFilter,TstringList(memo1.Lines));
    EStr1.text:='';
    EStr4.text:='';
  end;
  Panel4.Enabled:=Ecombo3.text<>'';
end;

procedure TF_SuperQueryDialog.ECombo3KeyPress(Sender: TObject;
  var Key: Char);
var mS:String;
begin
  if key=#13 then begin
    mS:=trim(ECombo3.text);
    if mS='' then exit;
    if mS[Length(mS)]<>';' then begin
      ECombo3.text:=Trim(mS)+';';
      ECombo3Change(sender);
    end;
  end;
end;

procedure TF_SuperQueryDialog.ECombo3Exit(Sender: TObject);
var mS:String;
begin
  mS:=Trim(ECombo3.text);
  if mS='' then exit;
  if mS[Length(mS)]<>';' then begin
    ECombo3.text:=Trim(mS)+';';
    ECombo3Change(sender);
  end;
end;

procedure TF_SuperQueryDialog.Button3Click(Sender: TObject);
var i:integer;
begin
  if Trim(ECombo3.text)='' then exit;
  if messageDlg('Do you want delete filter '+ECombo3.text+'?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
  Memo1.Clear;
  BlokEdit(Ecombo3.text,TStringList(memo1.lines),fFilter);
  i:=Ecombo3.Items.IndexOf(Trim(AnsiLowerCase(ECombo3.text)));
  if i>=0 then ECombo3.Items.delete(i);
end;

procedure TF_SuperQueryDialog.Button1Click(Sender: TObject);
begin
  Memo1Exit(sender);
  BlokEdit(Ecombo3.text,TStringList(memo1.lines),fFilter);
  if memo1.Lines.Count>0 then begin
    if Ecombo3.Items.IndexOf(Trim(AnsiLowerCase(ECombo3.text)))<0 then
      ECombo3.Items.add(Trim(AnsiLowerCase(ECombo3.text)));
  end;
end;

procedure TF_SuperQueryDialog.Memo1Exit(Sender: TObject);
var i:integer;
begin
  for i:=Memo1.Lines.Count-1 downto 0 do begin
    if Trim(Memo1.Lines.Strings[i])='' then memo1.Lines.delete(i);
  end;
end;

procedure TF_SuperQueryDialog.Button4Click(Sender: TObject);
var mS:String;
begin
  mS:=Execute_SuperFields(EDBGrid1);
  EStr1.text:=mS;
end;

procedure TF_SuperQueryDialog.EStr1Change(Sender: TObject);
var mS:String;
begin
  mS:=EDBGrid1.GetFieldName(Estr1.text,fF_sql,ff_dataset);
  CheckBox1.checked:= not (ord(fQuery.FindField(mS).dataType) in  cNumDBFields+cBooleanDBFields)
end;

procedure TF_SuperQueryDialog.Button2Click(Sender: TObject);
var i,j:integer;
    mRel,mV:String;
begin
  if trim(eStr1.text)='' then exit;
  if trim(eStr4.text)='' then exit;
  if trim(eCombo4.text)='' then exit;
  mRel:=lowercase(trim(ECombo4.text));
  i:=pos(':(',mRel);
  if i>0 then begin
    mRel:=trim(copy(mRel,i+2,255));
    mRel:=trim(copy(mRel,1,Length(mRel)-1));
    if Pos('like',mRel)>0 then begin
       if not CheckBox1.checked then begin messageDlg('Field '+EStr1.text+' is not text type',mtError,[mbOk],0); exit; end;
       i:=Pos(#39+'%',mRel);
       j:=Pos('%'+#39,mRel);
       mRel:='like';
       if (i>0) then begin
         if j>i then mV:=#39+'%'+EStr4.text+'%'+#39
         else mV:=#39+'%'+EStr4.text+#39
       end else begin
         if j>0 then mV:=#39+Estr4.text+'%'+#39;
       end;
    end;
  end;
  if Checkbox1.checked and (trim(lowerCase(mRel))<>'like') then mV:=#39+Estr4.text+#39;
  if memo1.lines.Count=0 then
    memo1.lines.add(EStr1.text+' '+mRel+' '+mV)
  else
    memo1.lines.add(' and '+EStr1.text+' '+mRel+' '+mV);
end;

procedure TF_SuperQueryDialog.MyExports;
var i:integer;
begin
  ListBox2.Items.Clear;
  for i:=0 to ListBox1.Items.Count-1 do
    ListBox2.Items.Add( EDBGrid1.GetFieldName(ListBox1.Items[i],ff_dataset,ff_title));
end;

procedure TF_SuperQueryDialog.ECombo6Exit(Sender: TObject);
var mS:String;
begin
  mS:=Trim(ECombo6.text);
  if mS='' then exit;
  if mS[Length(mS)]<>';' then begin
    ECombo6.text:=Trim(mS)+';';
    ECombo6Change(sender);
  end;
end;

procedure TF_SuperQueryDialog.ECombo6KeyPress(Sender: TObject;
  var Key: Char);
var mS:String;
begin
  if key=#13 then begin
    mS:=trim(ECombo6.text);
    if mS='' then exit;
    if mS[Length(mS)]<>';' then begin
      ECombo6.text:=Trim(mS)+';';
      ECombo6Change(sender);
    end;
  end;
end;

procedure TF_SuperQueryDialog.ECombo6Change(Sender: TObject);
var mS,mT:String;
begin
  mS:=trim(AnsiLowerCase(ECombo6.text));
  if mS='' then exit;
  if mS[length(mS)]<>';' then begin
    Panel5.Enabled:=false;
  end else begin
    Panel5.Enabled:=true;
    if BlokIndex(mS,fExport)>-1 then begin
      ListBox3.Clear;
      BlokBody(mS,fExport,TstringList(ListBox3.Items));
      mT:=Trim(BlokValue(mS,'format',fExport));
      if mT<>'' then begin
        case mT[1] of
        '1': RadioButton1.Checked:=true;
        '2': RadioButton2.Checked:=true;
        '3': RadioButton4.Checked:=true;
        '4': RadioButton6.Checked:=true;
        end;
      end;
    end;
  end;
end;

procedure TF_SuperQueryDialog.Button6Click(Sender: TObject);
var i:integer;
begin
  if Trim(ECombo6.text)='' then exit;
  if messageDlg('Do you want delete export format '+ECombo6.text+'?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
  ListBox3.Items.Clear;
  BlokEdit(Ecombo6.text,TStringList(ListBox3.Items),fExport);
  i:=Ecombo6.Items.IndexOf(Trim(AnsiLowerCase(ECombo6.text)));
  if i>=0 then ECombo6.Items.delete(i);
end;

procedure TF_SuperQueryDialog.Button5Click(Sender: TObject);
var i:integer;
begin
  BlokEdit(Ecombo6.text,TStringList(ListBox3.Items),fExport);
  if ListBox3.Items.Count>0 then begin
    if Ecombo6.Items.IndexOf(Trim(AnsiLowerCase(ECombo6.text)))<0 then
      ECombo6.Items.add(Trim(AnsiLowerCase(ECombo6.text)));
  end;
  i:=0;
  if RadioButton1.Checked then i:=1;
  if RadioButton2.Checked then i:=2;
  if RadioButton4.Checked then i:=3;
  if RadioButton6.Checked then i:=4;
  BlokValueEdit(Ecombo6.text,'format',intToStr(i),fExport);
end;

procedure TF_SuperQueryDialog.SpeedButton1Click(Sender: TObject);
var i,j:integer;
begin
  with ListBox2 do begin
    for i:=0 to Items.Count-1 do begin
      if Selected[i] then begin
        j:=ListBox3.Items.IndexOf(Items.Strings[i]);
        if j>-1 then ListBox3.Items.Delete(j);
        ListBox3.Items.add(Items.Strings[i]);
      end;
    end;
  end;
end;

procedure TF_SuperQueryDialog.SpeedButton3Click(Sender: TObject);
var i,j:integer;
begin
  with ListBox2 do begin
    for i:=0 to Items.Count-1 do begin
      j:=ListBox3.Items.IndexOf(Items.Strings[i]);
      if j>-1 then ListBox3.Items.Delete(j);
      ListBox3.Items.add(Items.Strings[i]);
    end;
  end;
end;

procedure TF_SuperQueryDialog.SpeedButton4Click(Sender: TObject);
var i:integer;
begin
  with ListBox3 do begin
    for i:=0 to Items.Count-1 do begin
      if Selected[i] then begin
        if Items.Count>1 then begin
           if i>0 then ItemIndex:=i-1 else ItemIndex:=i+1;
        end else ItemIndex:=-1;
        Items.delete(i);
      end;
    end;
  end;
end;

procedure TF_SuperQueryDialog.SpeedButton2Click(Sender: TObject);
begin
  ListBox3.Items.Clear;
end;

procedure TF_SuperQueryDialog.ExecuteExport;
var mS:String;
    mB:TbookMark;
    i,mCnt:integer;
    f:textFile;

    function GetLine:string;
    var mR,mQ:String;
       mField:TField;
       j:integer;
    begin
      mR:='';
      for j:=0 to ListBox4.Items.Count-1 do begin
        mField:=EDBGrid1.DataSource.DataSet.FindField(ListBox4.Items.Strings[j]);
        if mField=nil then Continue;
        if (mField.DataType in
                       [ftString, ftSmallint, ftInteger, ftWord, ftBoolean,
                        ftFloat, ftCurrency, ftDate, ftTime, ftDateTime, ftBytes,
                        ftVarBytes, ftAutoInc, ftFixedChar, ftWideString, ftLargeint])
        then begin
           mQ:=copy(mField.asString,1,200);
           if fexportType=2 then begin
            StringReplace(mQ,'"',#39,[rfReplaceAll]);
            mQ:='"'+mQ+'"';
          end;
          mR:=mR+#9+mQ;
        end;
        if (mField.DataType in [ftBlob, ftMemo, ftFmtMemo]) then begin
          mQ:=copy(mField.asString,1,200);
          StringReplace(mQ,#13#10,'  ',[rfReplaceAll]);
          StringReplace(mQ,#9,'  ',[rfReplaceAll]);
          if fexportType=2 then begin
            StringReplace(mQ,'"',#39,[rfReplaceAll]);
            mQ:='"'+mQ+'"';
          end;
          mR:=mR+#9+mQ;
        end;
      end;
      system.delete(mR,1,1);
      result:=mR;
    end;
begin
  mS:=''; mCnt:=0;
  if (EDBGrid1.DataSource.DataSet<>nil) and
     (EDBGrid1.DataSource.DataSet.Active) then begin
     with TQuery(EDBGrid1.DataSource.DataSet) do begin
       if IsEmpty then exit;
       if fExportType in [2,3] then begin
         AssignFile(f,SaveDialog1.FileName);
         Rewrite(f);
       end;
       mS:='';
       Screen.Cursor:=crHourGlass;
       mB:=GetBookMark;
       DisableControls;
       if (fExportType=4) and (EDBGrid1.SelectedRows.Count=0) or (Not (dgMultiSelect in EDBGrid1.Options))  then begin
         if dgRowSelect in EDBGrid1.Options then begin
            mS:=mS+GetLine; mCnt:=1;
         end else mS:=EDBGrid1.selectedField.asString;
       end else begin
         if EDBGrid1.SelectedRows.Count>0 then begin
           mCnt:=EDBGrid1.SelectedRows.Count;
           for i:=0 to EDBGrid1.SelectedRows.Count-1 do begin
              GotoBookmark(pointer(EDBGrid1.SelectedRows.Items[i]));
              if fExportType in [2,3] then Writeln(f,GetLine);
              if fExportType=4 then mS:=mS+getLine+#13#10;
           end;
         end else begin
           First; mCnt:=0;
           while not Eof do begin
              inc(mCnt);
              if fExportType in [2,3] then Writeln(f,GetLine);
              if fExportType=4 then mS:=mS+GetLine+#13#10;
              Next;
           end;
         end;
       end;
       if fExportType=4 then Clipboard.AsText:=mS;
       if mB<>nil then begin
         GotoBookMark(mB);
         freeBookMark(mB);
       end;
       EnableControls;
       Screen.Cursor:=crDefault;
     end;
     if fExportType in [2,3] then begin
       CloseFile(f);
       MessageDlg('Export to file "'+SaveDialog1.FileName+'" - OK '+#13+'Exported row count '+IntToStr(mCnt),mtInformation,[mbOk],0);
     end;
     if fExportType=4 then begin
       MessageDlg('Export to clipboard - OK '+#13+'Exported row count '+IntToStr(mCnt),mtInformation,[mbOk],0);
     end;
  end;
end;


procedure TF_SuperQueryDialog.ECombo2Change(Sender: TObject);
var mS,mT:String;
    i:integer;
begin
  Button7.Enabled:=Trim(Ecombo2.text)<>'';
  ListBox4.Items.Clear;
  BlokBody(ECombo2.text,fExport,TStringList(ListBox4.Items));
  mS:=Trim(BlokValue(ECombo2.text,'format',fExport));
  if mS<>'' then fExportType:=StrToInt(copy(mS,1,1)) else fExportType:=0;
  for i:=0 to ListBox4.Items.Count-1 do begin
    mT:=ListBox4.Items.Strings[i];
    mT:=EDBGrid1.GetFieldName(mT,ff_title,ff_dataset);
    ListBox4.Items.Strings[i]:=mT;
  end;
end;

procedure TF_SuperQueryDialog.Button7Click(Sender: TObject);
var mS:String;
begin
  mS:=Trim(ECombo2.text);
  if mS='' then begin ShowMessage('Export name not defined');exit; end;
  while Pos(';',mS)>0 do delete(mS,Pos(';',mS),1);
  SaveDialog1.FileName:=mS+'.txt';
  if fExportType<>4 then begin
    if SaveDialog1.Execute then ExecuteExport;
  end else ExecuteExport;
end;

procedure TF_SuperQueryDialog.SpeedButton5Click(Sender: TObject);
var j:integer;
begin
  j:=ListBox3.ItemIndex;
  if j>0 then begin
    ListBox3.Items.Move(j,j-1);
    ListBox3.ItemIndex:=j-1;
  end;
end;

procedure TF_SuperQueryDialog.SpeedButton6Click(Sender: TObject);
var j:integer;
begin
  j:=ListBox3.ItemIndex;
  if (j>=0) and (j<ListBox3.Items.Count-1) then begin
    ListBox3.Items.Move(j,j+1);
    ListBox3.ItemIndex:=j+1;
  end;
end;

procedure TF_SuperQueryDialog.ECombo1Change(Sender: TObject);
begin
  Memo2.Lines.Clear;
  if Trim(ECombo1.text)<>'' then begin
    BlokBody(ECombo1.text,fFilter,TStringList(memo2.Lines));
    If fOldFilter<>'' then EDBGrid1.deleteFromWhere(fOldFilter);
    fOldFilter:=Trim(Memo2.Lines.text);
    EDBGrid1.SQLAddToWhere:=Trim(memo2.Lines.text);
    EDBGrid1.AcceptSQL;
  end else begin
    If fOldFilter<>'' then EDBGrid1.deleteFromWhere(fOldFilter);
    fOldFilter:='';
  end;
end;

procedure TF_SuperQueryDialog.Button8Click(Sender: TObject);
begin
  close;
end;

procedure TF_SuperQueryDialog.Button10Click(Sender: TObject);
begin
 fQuery.Close;
 fQuery.Open;
end;

procedure TF_SuperQueryDialog.Button11Click(Sender: TObject);
//zotavenie z error
begin
 fOldFilter:='';
 try  EFilter1.text:=''; except end;
 try  ECombo1.text:=''; except end;
 fQuery.SQL.text:=fStartSQL;
 EDBGrid1.NewQuery;
 fQuery.Close;
 fQuery.Open;
end;

end.

